'****************************************************************************
'
' Spam-Proxy   : SPAMPRXY (transparenter Spam-Filter)
' Version      : 0.25
' Compilation  : Thomas Gohel (gohel@basicguru.com)
' Last Files at: http://www.gohel.de
'
'
'****************************************************************************

%Console_Win = 1                            ' fr Console kompilieren (1=CC, 0=GUI)

$IF %Console_Win
    $COMPILE EXE "SPAMPRXY.EXE"             ' Console Debug
$ELSE
    $COMPILE EXE "SPAMPRXY.EXE"             ' GUI Standard-Version
$ENDIF
$DIM ALL                                    ' alle Variablen deklarieren (gut fr Tipfehler)
$DEBUG ERROR ON                             ' verbesserter Bound/Numeric-Check
$RESOURCE "SPAMPRXY.PBR"                    ' Spam-Proxy Resourcefile
$INCLUDE "WIN32API.INC"                     ' Win32-API Deklarationen
$INCLUDE "WSOCK32.INC"                      ' WSock32-API Deklarationen
$INCLUDE "SPAMPRXY.INC"                     ' globale Spam-Proxy Definitionen
$INCLUDE "MD5.INC"                          ' MD5 Algorithmen (APOP)
$INCLUDE "CRC32.INC"                        ' CRC32 Routines (UIDL)
%PBWriteCon = 0                             ' STDOUT-Ausgaben unterdrcken (via Logfile)
                                            ' -1/Ein 0/Aus
%WM_TRAYICON = %WM_USER + 400               ' TrayIcon-Konstanten fr Message-Handler

DECLARE SUB MediaPlay(Wavfile AS ASCIIZ)

DECLARE FUNCTION SpamProxy(BYVAL Dummy AS LONG) AS LONG
DECLARE FUNCTION Pop3Listen(BYVAL Pop3Port AS LONG) AS LONG
DECLARE FUNCTION Pop3IncomingLogin(BYVAL hIntern AS LONG, hPop3 AS LONG, Pop3Server AS STRING, _
                                   Pop3User AS STRING, Pop3Pass AS STRING, Messages AS LONG, _
                                   MsgSize AS LONG , MailAktiv() AS LONG, MailDeleted() AS LONG, _
                                   MailMsgId() AS STRING, MailUidl() AS STRING, Maillaenge() AS LONG) AS LONG
DECLARE FUNCTION Pop3Authentication(BYVAL hPop3 AS LONG, BYVAL Pop3User AS STRING, _
                                    BYVAL Pop3Pwd AS STRING, BYVAL Pop3Auth AS STRING, BYVAL APop AS LONG, _
                                    BYVAL APopChallenge AS STRING) AS LONG
DECLARE FUNCTION Pop3AuthSaslDetect(BYVAL Pop3Auth AS STRING, BYVAL Pop3AuthInfo AS STRING) AS LONG
DECLARE FUNCTION Pop3AuthSasl(BYVAL hPop3 AS LONG, BYVAL Pop3User AS STRING, BYVAL Pop3Pwd AS STRING, _
                              BYVAL Pop3AuthFlag AS LONG) AS LONG
DECLARE FUNCTION Pop3GetMailBox(BYVAL hPop3 AS LONG, BYVAL Pop3Server AS STRING, BYVAL Pop3User AS STRING, _
                                Messages AS LONG, MsgSize AS LONG, MailAktiv() AS LONG, _
                                MailDeleted() AS LONG, MailMsgId() AS STRING, MailUidl() AS STRING, _
                                MailLaenge() AS LONG, BYVAL Pop3Envelope AS STRING) AS LONG

DECLARE FUNCTION Pop3GetStat(BYVAL hPop3 AS LONG, Messages AS LONG, MsgSize AS LONG) AS LONG
DECLARE FUNCTION Pop3GetList(BYVAL hPop3 AS LONG, MailAktiv() AS LONG, Maillaenge() AS LONG) AS LONG
DECLARE FUNCTION Pop3GetUidl(BYVAL hPop3 AS LONG, MsgSart AS LONG, BYVAL Messages AS LONG, _
                             MailUidl() AS STRING) AS LONG
DECLARE FUNCTION Pop3GetTop(BYVAL hPop3 AS LONG, BYVAL Pop3Server AS STRING, BYVAL Pop3User AS STRING, _
                            BYVAL MsgNumber AS LONG, MailAktiv() AS LONG, MailDeleted() AS LONG, _
                            BYVAL Pop3Envelope AS STRING) AS LONG
DECLARE FUNCTION Pop3GetCheck(BYVAL hPop3 AS LONG, BYVAL Pop3Server AS STRING, BYVAL Pop3User AS STRING, _
                              MailStatus AS LONG, BYVAL Mailto AS STRING, BYVAL MailFrom AS STRING, _
                              BYVAL Betreff AS STRING, BYVAL MsgID AS STRING, BYVAL MsgBezug AS STRING, _
                              BYVAL Pop3MailSize AS LONG, CSHeader() AS STRING, CSZiel AS STRING, _
                              HdrBuffer AS STRING, BYVAL RBL AS STRING) AS LONG
DECLARE FUNCTION Pop3GetFilter(BYVAL Mailto AS STRING, BYVAL MailFrom AS STRING, _
                               BYVAL Betreff AS STRING, BYVAL MsgID AS STRING, _
                               BYVAL MsgBezug$, CSHeader() AS STRING, CSZiel AS STRING, _
                               CSZeile AS STRING) AS LONG
DECLARE FUNCTION Pop3GetDele(BYVAL hPop3 AS LONG, BYVAL MsgNumber AS LONG) AS LONG
DECLARE FUNCTION Pop3TransferTop(BYVAL Arg AS STRING, BYVAL hIntern AS LONG, _
                                 BYVAL hextern AS LONG, BYVAL Messages AS LONG, _
                                 BYVAL MsgCount AS LONG, MailAktiv() AS LONG, _
                                 MailDeleted() AS LONG, Maillaenge() AS LONG, _
                                 BYVAL Mailfilter AS LONG) AS LONG
DECLARE FUNCTION Pop3TransferRetr(BYVAL Arg AS STRING, BYVAL hIntern AS LONG, _
                                  BYVAL hExtern AS LONG, BYVAL Messages AS LONG, _
                                  BYVAL MsgCount AS LONG, MailAktiv() AS LONG, _
                                  MailDeleted() AS LONG, Maillaenge() AS LONG, _
                                  BYVAL Mailfilter AS LONG) AS LONG
DECLARE FUNCTION Pop3TransferDele(BYVAL Arg AS STRING, BYVAL hIntern AS LONG, BYVAL hExtern AS LONG, _
                                  BYVAL Messages AS LONG, BYVAL MsgCount AS LONG, MsgNew AS LONG, _
                                  MsgSizeNew AS LONG, MailAktiv() AS LONG, MailDeleted() AS LONG, _
                                  MailLaenge() AS LONG, BYVAL Mailfilter AS LONG) AS LONG
DECLARE FUNCTION Pop3PutList(BYVAL Arg AS STRING, BYVAL hIntern AS LONG, BYVAL Messages AS LONG, _
                             BYVAL MsgCount AS LONG, BYVAL MsgNew AS LONG, MailAktiv() AS LONG, _
                             MailDeleted() AS LONG, MailLaenge() AS LONG) AS LONG
DECLARE FUNCTION Pop3PutUidl(BYVAL Arg AS STRING, BYVAL hIntern AS LONG, BYVAL Messages AS LONG, _
                             BYVAL MsgCount AS LONG, BYVAL MsgNew AS LONG, MailAktiv() AS LONG, _
                             MailDeleted() AS LONG, MailUidl() AS STRING) AS LONG
DECLARE FUNCTION Pop3PutHelp(BYVAL hIntern AS LONG) AS LONG
DECLARE FUNCTION Pop3KillLog(BYVAL hPop3 AS LONG) AS LONG
DECLARE FUNCTION Pop3KillTop(BYVAL hPop3 AS LONG) AS STRING
DECLARE FUNCTION Pop3KillLogAdd(BYVAL hPop3 AS LONG, BYVAL Pop3Server AS STRING, BYVAL Pop3User AS STRING, _
                                BYVAL Mailfrom AS STRING, BYVAL MailTo AS STRING, BYVAL Betreff AS STRING, _
                                BYVAL MsgId AS STRING, BYVAL Pop3MailSize AS LONG, CSHeader() AS STRING, _
                                BYVAL CSReason AS STRING, BYVAL CSSearch AS STRING, BYVAL CSResult AS STRING, _
                                BYVAL RBL_Info AS STRING) AS LONG
DECLARE FUNCTION Pop3KillPrepare(CSZeile AS STRING, CSReason AS STRING, CSSearch AS STRING, CSResult AS STRING, _
                                RBL_Info AS STRING) AS LONG
DECLARE FUNCTION SmtpNextLine(BYVAL SmtpSplHdl AS LONG, LineCount AS LONG, EoFile AS LONG) AS STRING

DECLARE FUNCTION NntpListen(BYVAL NntpPort AS LONG) AS LONG
DECLARE FUNCTION NntpIncomingLogin(BYVAL hIntern AS LONG, hExtern AS LONG, NntpServer AS STRING, _
                                   NntpUser AS STRING, NntpPass AS STRING) AS LONG
DECLARE FUNCTION NntpAuthentication(BYVAL hNntp AS LONG, BYVAL NntpUser AS STRING, _
                                    BYVAL NntpPass AS STRING, Response AS STRING) AS LONG
DECLARE FUNCTION NntpReadGroup(BYVAL hIntern AS LONG, BYVAL hExtern AS LONG, _
                               BYVAL Newsgroup AS STRING, BYVAL Cmd AS STRING) AS LONG
DECLARE FUNCTION NntpFilterArticle(BYVAL Newsgroup AS STRING, BYVAL MailFrom AS STRING, _
                                   BYVAL Betreff AS STRING, BYVAL MsgID AS STRING, _
                                   BYVAL MsgBezug AS STRING, CSZiel AS STRING, CSZeile AS STRING) AS LONG

DECLARE FUNCTION RBL_Open() AS LONG
DECLARE FUNCTION RBL_Check(BYVAL IP AS DWORD, Reason AS STRING) AS LONG
DECLARE FUNCTION RBL_ScanReceived(BYVAL Buffer AS STRING, Reason AS STRING) AS LONG
DECLARE FUNCTION IP_Open() AS LONG
DECLARE FUNCTION IP_Access(BYVAL UnixIP AS LONG) AS LONG
DECLARE FUNCTION IP_Check(BYVAL IP AS QUAD) AS LONG

DECLARE FUNCTION TCP_Freefile() AS LONG
DECLARE FUNCTION TCP_FreeHandle(BYVAL Index AS LONG) AS LONG
DECLARE FUNCTION TCP_Open(BYVAL ServerName AS STRING, BYVAL ServerPort AS LONG) AS DWORD
DECLARE FUNCTION TCP_Close(BYVAL hTcp AS LONG) AS LONG
DECLARE SUB      TCP_Abort(BYVAL hTcp AS LONG)
DECLARE FUNCTION TCP_Print(BYVAL hSocket AS LONG, BYVAL TEXT AS STRING) AS LONG
DECLARE FUNCTION TCP_Send(BYVAL hSocket AS LONG, BYVAL TEXT AS STRING) AS LONG
DECLARE SUB      TCP_Line(BYVAL hsocket AS LONG, Buffer AS STRING)
DECLARE FUNCTION TCP_Copy(BYVAL hFrom AS LONG, BYVAL hTo AS LONG) AS LONG

DECLARE SUB MediaPlay(Wavfile AS ASCIIZ)

TYPE Thread_Data                 ' Datenstruktur fr die jeweiligen Prozessdatenstze
     hThread       AS LONG       ' Thread-Handle fr PowerBASIC
     hSocket       AS LONG       ' Winsock-Handle
     IP            AS LONG       ' IP-Adresse (Incoming Connections)
     SocketTimeout AS LONG       ' Wartezeit auf Antworten vom Server (bis TCP_Line abbricht)
     SocketExitus  AS LONG       ' definiert Zeit bis ein Thread als 'gestorben' erkannt wird
     SocketError   AS LONG       ' Fehler in der Winsock erkannt
     Portnummer    AS LONG       ' Portnummer
     User          AS ASCIIZ*32  '
END TYPE

TYPE Mail_Data
     Aktiv         AS LONG
     Deleted       AS LONG
     Laenge        AS LONG
END TYPE

DEFLNG A-Z

GLOBAL Pop3LogDir          AS STRING      '
GLOBAL Pop3Timeout         AS LONG        '
GLOBAL Pop3MaxLen          AS LONG        '
GLOBAL Pop3MailFiltered    AS LONG        '
GLOBAL Pop3MailKilled      AS LONG        '
GLOBAL Pop3PortIncoming    AS LONG        '
GLOBAL Pop3PortOutgoing    AS LONG        '
GLOBAL Pop3KillMsg()       AS STRING      ' Pop3 Information ber gelschte Pop3-Mails
GLOBAL Pop3Blacklist()     AS STRING      ' RBL beinhaltet Relay-Blacklist
GLOBAL Pop3BlackIPs1()     AS QUAD        ' RBL QUAD, DWORD/LONG-Rechnungsfehler vermeiden
GLOBAL Pop3BlackIPs2()     AS QUAD        ' RBL QUAD, DWORD/LONG-Rechnungsfehler vermeiden
GLOBAL Pop3BlacklistMax    AS LONG        ' RBL
GLOBAL NntpTimeOut         AS LONG        '
GLOBAL NntpPortIncoming    AS LONG        '
GLOBAL NntpPortOutgoing    AS LONG        '
GLOBAL IPAccess1()         AS QUAD        '
GLOBAL IPAccess2()         AS QUAD
GLOBAL IPAccessMax         AS LONG

GLOBAL LogFilter           AS LONG        ' Filter
GLOBAL LogSession          AS LONG        ' Connect/Disconnect/IP-Adressen
GLOBAL LogDebug            AS LONG        ' Debug

GLOBAL CpsRcvd             AS LONG        '
GLOBAL Killfile            AS STRING      '
GLOBAL KillReport          AS STRING      ' Zieladresse fr Info-Mail
GLOBAL Debugline           AS LONG        ' Line Ein- & Ausgaben anzeigen

GLOBAL MsgNoSuch           AS STRING
GLOBAL MsgCmdUnknown       AS STRING
GLOBAL TempBuffer()        AS STRING      ' globaler LineIn Buffer
GLOBAL GlobalExit          AS LONG        ' Threads beenden
GLOBAL Key                 AS STRING

$INCLUDE "LOGFILE.BAS"                    ' globale Logfile-Routinen
$INCLUDE "CONFIG.INC"                     ' Konfiguration parsen
$INCLUDE "CS32.INC"                       ' CrossSecretary Plugin
$INCLUDE "GLOBALQP.INC"

GLOBAL hInst               AS LONG        ' globales Windows Handle fr SpamProxy
GLOBAL hSpamProxy          AS LONG        ' globales Thread Handle
GLOBAL hlisten             AS LONG
GLOBAL Pr()                AS Thread_Data ' Datenstze fr die jeweiligen laufenden Prozesse

GLOBAL Errorflag AS LONG

%Threads       = 100                      '
%WSock_Version = &h0101                   '


'-------------------------------------------------------------------------------------------
' Pop3, Authentication on Server
'-------------------------------------------------------------------------------------------
FUNCTION Pop3Authentication(BYVAL hPop3 AS LONG, BYVAL Pop3User AS STRING, BYVAL Pop3Pwd AS STRING, BYVAL Pop3Auth AS STRING, BYVAL APop AS LONG, BYVAL APopChallenge AS STRING) AS LONG

        LOCAL Pop3AuthInfo AS STRING      ' String mit Untersttzung fr verschiedene Auth-
                                          ' Verfahren
        LOCAL Challenge    AS STRING      '
        LOCAL Pop3AuthFlag AS INTEGER     ' 1=LOGIN, 2=PLAIN, 3=DIGEST-MD5, 4=CRAM-MD5
        LOCAL Buffer       AS STRING      ' Rcvd-Buffer
        LOCAL Result       AS LONG        '

        ON ERROR GOTO Pop3AuthenticationError

        FUNCTION = %False

        SELECT CASE UCASE$(Pop3Auth)
            ' Pop3Auth bzw. SASL mit AUTH (Vorlufer von SASL, wird von NC 4.x verwendet)
            CASE "AUTH"
                TCP_SEND hPop3, "AUTH" + EOL$
                TCP_LINE hPop3, Buffer
                CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                Logwrite Buffer, hPop3, %LogState_Debug
                IF LEFT$(Buffer, 3) = "+OK" THEN
                    DO
                        TCP_LINE hPop3, Buffer
                        CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                        IF Buffer$ <> "." THEN
                            Logwrite Buffer, hPop3, %LogState_Debug
                            Pop3AuthInfo$ = Pop3AuthInfo$ + Buffer + CHR$(8)
                        END IF
                    LOOP UNTIL Buffer$ = "."
                    Pop3AuthFlag = Pop3AuthSaslDetect(Pop3Auth, Pop3AuthInfo)
                    FUNCTION = Pop3AuthSasl(hPop3, Pop3User, Pop3Pwd, Pop3AuthFlag)
                ELSE
                    Logwrite Buffer, hPop3, %LogState_FatalError
                END IF
            ' Pop3Auth bzw. SASL mit CAPA
            CASE "SASL"
                TCP_SEND hPop3, "CAPA" + EOL$
                TCP_LINE hPop3, Buffer
                CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                Logwrite Buffer, hPop3, %LogState_Debug
                IF LEFT$(Buffer, 3) = "+OK" THEN
                    DO
                        TCP_LINE hPop3, Buffer
                        CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                        IF Buffer$ <> "." THEN
                            Logwrite Buffer, hPop3, %LogState_Debug
                            IF LEFT$(Buffer$, 4) = "SASL" THEN
                                Pop3AuthInfo$ = MID$(Buffer$, 5)
                            END IF
                        END IF
                    LOOP UNTIL Buffer$ = "."
                    Pop3AuthFlag = Pop3AuthSaslDetect(Pop3Auth, Pop3AuthInfo)
                    FUNCTION = Pop3AuthSasl(hPop3, Pop3User, Pop3Pwd, Pop3AuthFlag)
                ELSE
                END IF
            CASE "LOGIN"
                FUNCTION = Pop3AuthSasl(hPop3, Pop3User, Pop3Pwd, 1)
            CASE "PLAIN"
                FUNCTION = Pop3AuthSasl(hPop3, Pop3User, Pop3Pwd, 2)
            CASE "DIGEST-MD5"
                FUNCTION = Pop3AuthSasl(hPop3, Pop3User, Pop3Pwd, 3)
            CASE "CRAM-MD5"
                FUNCTION = Pop3AuthSasl(hPop3, Pop3User, Pop3Pwd, 4)
            ' APOP
            CASE "APOP"
                Logwrite "Sending APOP", hPop3, %LogState_BriefMsg
                TCP_SEND hPop3, "APOP " + Pop3User + " " + Get_Digest_MD5(APopChallenge + Pop3Pwd) + Eol$
                TCP_LINE hPop3, Buffer
                CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                Logwrite Buffer, hPop3, %LogState_Debug
                IF LEFT$(Buffer, 3) = "+OK" THEN
                    Logwrite "POP3 Authentication established", hPop3, %LogState_RasDialResp
                    FUNCTION = %True
                ELSE
                    Logwrite Buffer, hPop3, %LogState_FatalError
                END IF
            ' Standard USER/PASS
            CASE ELSE
                IF Pop3User$ = "" THEN
                    ' ohne USER/PASS Authentifizierung
                    Logwrite "POP3 Connection established", hPop3, %LogState_RasDialResp
                    FUNCTION = %True
                ELSE
                    ' Standard USER/PASS Authentifizierung
                    Logwrite "Sending USER", hPop3, %LogState_BriefMsg
                    TCP_SEND hPop3, "USER " + Pop3User + Eol$
                    TCP_LINE hPop3, Buffer
                    CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                    Logwrite Buffer, hPop3, %LogState_Debug
                    IF LEFT$(Buffer, 3) = "+OK" THEN
                        Logwrite "Sending PASS", hPop3, %LogState_BriefMsg
                        TCP_SEND hPop3, "PASS " + Pop3Pwd + Eol$
                        TCP_LINE hPop3, Buffer
                        CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                        Logwrite Buffer, hPop3, %LogState_Debug
                        IF LEFT$(Buffer, 3) = "+OK" THEN
                            Logwrite "POP3 Connection established", hPop3, %LogState_RasDialResp
                            FUNCTION = %True
                        ELSE
                            Logwrite Buffer, hPop3, %LogState_FatalError
                        END IF
                    ELSE
                        Logwrite Buffer, hPop3, %LogState_FatalError
                    END IF
                END IF
END SELECT
        EXIT FUNCTION

Pop3AuthenticationError:

END FUNCTION

'-------------------------------------------------------------------------------------------
' Pop3, SASL-Authentication erkennen
'-------------------------------------------------------------------------------------------
FUNCTION Pop3AuthSaslDetect(BYVAL Pop3Auth AS STRING, BYVAL Pop3AuthInfo AS STRING) AS LONG

        LOCAL Pop3AuthFlag AS INTEGER     ' 1=LOGIN, 2=PLAIN, 3=DIGEST-MD5, 4=CRAM-MD5

        ON ERROR RESUME NEXT

        FUNCTION = 0

        SELECT CASE UCASE$(Pop3Auth$)
            CASE "AUTH", "SASL"
                ' LOGIN vor PLAIN vorziehen
                IF INSTR(Pop3AuthInfo, "PLAIN")      > 0 THEN Pop3AuthFlag = 2
                IF INSTR(Pop3AuthInfo, "LOGIN")      > 0 THEN Pop3AuthFlag = 1
                IF INSTR(Pop3AuthInfo, "DIGEST-MD5") > 0 THEN Pop3AuthFlag = 3
                ' ebenso CRAM-MD5 als sichere Variante
                IF INSTR(Pop3AuthInfo, "CRAM-MD5")   > 0 THEN Pop3AuthFlag = 4
            CASE "LOGIN"
                Pop3AuthFlag = 1
            CASE "PLAIN"
                Pop3AuthFlag = 2
            CASE "DIGEST-MD5"
                Pop3AuthFlag = 3
            CASE "CRAM-MD5"
                Pop3AuthFlag = 4
        END SELECT

        FUNCTION = Pop3AuthFlag

END FUNCTION

'-------------------------------------------------------------------------------------------
' Pop3, SASL-Authentication on Server
'-------------------------------------------------------------------------------------------
FUNCTION Pop3AuthSasl(BYVAL hPop3 AS LONG, BYVAL Pop3User AS STRING, BYVAL Pop3Pwd AS STRING, BYVAL Pop3AuthFlag AS LONG) AS LONG

        LOCAL Challenge    AS STRING      '
        LOCAL Buffer       AS STRING      ' Rcvd-Buffer
        LOCAL Result       AS LONG        '
        LOCAL i            AS LONG        ' Temp
        LOCAL a            AS STRING      ' Temp
        LOCAL realm        AS STRING      ' Digest-MD5 Challenge/Handshake
        LOCAL nonce        AS STRING      ' Digest-MD5 Challenge/Handshake
        LOCAL qop          AS STRING      ' Digest-MD5 Challenge/Handshake
        LOCAL algorithm    AS STRING      ' Digest-MD5 Challenge/Handshake
        LOCAL charset      AS STRING      ' Digest-MD5 Challenge/Handshake
        LOCAL nc           AS STRING      ' Digest-MD5 Challenge/Handshake
        LOCAL cnonce       AS STRING      ' Digest-MD5 Challenge/Handshake
        LOCAL username     AS STRING      ' Digest-MD5 Challenge/Handshake
        LOCAL response     AS STRING      ' Digest-MD5 Challenge/Handshake
        LOCAL digesturi    AS STRING      ' Digest-MD5 Challenge/Handshake
        LOCAL A1           AS STRING      ' Digest-MD5 Hashes
        LOCAL A2           AS STRING      ' Digest-MD5 Hashes

        ON ERROR GOTO Pop3AuthSaslError

        FUNCTION = %False

        SELECT CASE Pop3AuthFlag
            ' AUTH LOGIN
            CASE 1
                Logwrite "Sending AUTH LOGIN", hPop3, %LogState_BriefMsg
                TCP_SEND hPop3, "AUTH LOGIN" + Eol$
                TCP_LINE hPop3, Buffer
                CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                IF LEFT$(Buffer, 1) = "+" THEN
                    Logwrite "Sending Username", hPop3, %LogState_BriefMsg
                    TCP_SEND hPop3, Get_Base64_Encode$(Pop3User$) + Eol$
                    TCP_LINE hPop3, Buffer
                    CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                    IF LEFT$(Buffer, 1) = "+" THEN
                        Logwrite "Sending Password", hPop3, %LogState_BriefMsg
                        TCP_SEND hPop3, Get_Base64_Encode$(Pop3Pwd$) + Eol$
                        TCP_LINE hPop3, Buffer
                        CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                        IF LEFT$(Buffer, 3) = "+OK" THEN
                            Logwrite "POP3 Authentication established", hPop3, %LogState_RasDialResp
                            FUNCTION = %True
                        ELSE
                            Logwrite Buffer, hPop3, %LogState_FatalError
                        END IF
                    ELSE
                        Logwrite Buffer, hPop3, %LogState_FatalError
                    END IF
                ELSE
                    Logwrite Buffer, hPop3, %LogState_FatalError
                END IF
            ' AUTH PLAIN
            CASE 2
                Logwrite "Sending AUTH PLAIN", hPop3, %LogState_BriefMsg
                TCP_SEND hPop3, "AUTH PLAIN" + Eol$
                TCP_LINE hPop3, Buffer
                CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                IF LEFT$(Buffer, 1) = "+" THEN
                    TCP_SEND hPop3, Get_Base64_Encode$(CHR$(0) + Pop3User + CHR$(0)+ Pop3Pwd) + Eol$
                    TCP_LINE hPop3, Buffer
                    CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                    IF LEFT$(Buffer, 1) = "+" THEN
                        Logwrite "POP3 Authentication established", hPop3, %LogState_RasDialResp
                        FUNCTION = %True
                    ELSE
                        Logwrite Buffer, hPop3, %LogState_FatalError
                    END IF
                ELSE
                    Logwrite Buffer, hPop3, %LogState_FatalError
                END IF
            CASE 3
                Logwrite "Sending AUTH DIGEST-MD5", hPop3, %LogState_BriefMsg
                TCP_SEND hPop3, "AUTH DIGEST-MD5" + Eol$
                TCP_LINE hPop3, Buffer
                CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                IF LEFT$(Buffer, 1) = "+" THEN
                    Challenge = Get_Base64_Decode$(MID$(Buffer$, 3), 0)
                    Logwrite Challenge, hPop3, %LogState_Debug
                    ' Challenge zerlegen
                    IF INSTR(Challenge, "charset=") > 0 THEN
                       'PRINT "wrong charset"
                       ' Default Charset wird nicht verwenden
                    END IF
                    ' Servernamen ermitteln
                    i& = INSTR(Challenge, "realm=")
                    IF i& = 0 THEN
                        realm = ""
                    ELSE
                        realm = MID$(Challenge, i& + 7)
                        realm = MID$(realm, 1, INSTR(realm, CHR$(34)) - 1)
                    END IF
                    ' nonce /Hash-Wert ermitteln
                    i& = INSTR(Challenge, "nonce=")
                    IF i& > 0 THEN
                        nonce = MID$(Challenge, i& + 7)
                        nonce = MID$(nonce, 1, INSTR(nonce, CHR$(34)) - 1)

                        ' algorithm ermitteln
                        i& = INSTR(Challenge, "algorithm=")
                        IF i& > 0 THEN
                            algorithm = MID$(Challenge, i& + 10)
                            algorithm = MID$(algorithm, 1, INSTR(algorithm, ",") - 1)
                            algorithm = REMOVE$(algorithm, CHR$(34))

                            IF algorithm = "md5-sess" THEN
                                ' hash quality ermitteln
                                i& = INSTR(Challenge, "qop=")
                                IF i& = 0 THEN
                                    ' Default
                                    qop = "auth"
                                ELSE
                                    qop = MID$(Challenge, i& + 4)
                                    qop = MID$(qop, 1, INSTR(qop, ",") - 1)
                                    qop = REMOVE$(qop, CHR$(34))
                                END IF
                                IF qop = "auth" THEN

                                    ' Antwort-Challenge erstellen
                                    digesturi = "pop3/" + realm '+ "/" + LCASE$(Pop3Server)
                                    ' neuen Hashwert erstellen
                                    RANDOMIZE TIMER
                                    cnonce = Get_Cram_MD5(HEX$(RND(1, 32767), 4), nonce)
                                    nc ="00000001"

                                    A1 = Get_String_MD5(Pop3User + ":" + realm + ":" + Pop3Pwd) + ":" + nonce + _
                                         ":" + cnonce
                                    A2 = "AUTHENTICATE:" + digesturi
                                    response = Get_Digest_MD5(Get_Digest_MD5(A1) + _
                                               ":" + nonce + ":" + nc +":" + _
                                               cnonce + ":" + qop + ":" + _
                                               Get_Digest_MD5(A2))

                                    ' endgltige Client-Response erstellen
                                    Challenge = "username=" + CHR$(34) + Pop3User + CHR$(34) + "," + _
                                                "realm=" + CHR$(34) + realm + CHR$(34) + "," + _
                                                "nonce=" + CHR$(34) + nonce + CHR$(34) + "," + _
                                                "nc=" + nc + "," + _
                                                "cnonce=" + CHR$(34) + cnonce + CHR$(34) + "," + _
                                                "digest-uri=" + CHR$(34) + digesturi + CHR$(34) + "," + _
                                                "response=" + response + "," + _
                                                "qop=" + qop

                                    Logwrite "Challenge: " + Challenge, hPop3, %LogState_Debug
                                    TCP_SEND hPop3, Get_Base64_Encode$(Challenge) + Eol$
                                    TCP_LINE hPop3, Buffer
                                    CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                                    IF LEFT$(Buffer, 1) = "+" THEN
                                        Challenge = Get_Base64_Decode$(MID$(Buffer, 3), 0)
                                        IF LEFT$(Challenge, 8) = "rspauth=" THEN
                                            ' Hashwert ermitteln
                                            Challenge = MID$(Challenge, 9)
                                            Logwrite Challenge, hPop3, %LogState_Debug
                                            A2 = ":" + digesturi
                                            response = Get_Digest_MD5(Get_Digest_MD5(A1) + _
                                                       ":" + nonce + ":" + nc +":" + cnonce + _
                                                       ":" + qop + ":" + _
                                                       Get_Digest_MD5(A2))
                                            IF Challenge = response THEN
                                                TCP_SEND hPop3, Eol$
                                                Logwrite "POP3 Authentication established", hPop3, %LogState_RasDialResp
                                                FUNCTION = %True
                                            ELSE
                                                a$ = "AUTH/2 Response hash failure"
                                                Logwrite a$, hPop3, %LogState_FatalError
                                            END IF
                                        ELSE
                                            a$ = "AUTH/2 rspauth failure"
                                            Logwrite a$, hPop3, %LogState_FatalError
                                        END IF
                                    ELSE
                                        a$ = "AUTH/1 Handshake/Client Challenge failure"
                                        Logwrite a$, hPop3, %LogState_FatalError
                                    END IF
                                ELSE
                                    a$ = "Not supportet hash quality protection '" + qop +"'"
                                    Logwrite a$, hPop3, %LogState_FatalError
                                END IF
                            ELSE
                                a$ = "Not supportet hash algorithm '" + algorithm +"'"
                                Logwrite a$, hPop3, %LogState_FatalError
                            END IF
                        ELSE
                            Logwrite "Missing 'algorithm' in Challenge", hPop3, %LogState_FatalError
                        END IF
                    ELSE
                        Logwrite "Missing 'nonce' in Challenge", hPop3, %LogState_FatalError
                    END IF
                ELSE
                    Logwrite Buffer, hPop3, %LogState_FatalError
                END IF

            ' CRAM-MD5
            CASE 4
                Logwrite "Sending AUTH CRAM-MD5", hPop3, %LogState_BriefMsg
                TCP_SEND hPop3, "AUTH CRAM-MD5" + Eol$
                TCP_LINE hPop3, Buffer
                CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                IF LEFT$(Buffer, 1) = "+" THEN
                    Challenge$ = Get_Base64_Decode$(MID$(Buffer, 3), 0)
                    Logwrite "Sending Username/Password", hPop3, %LogState_BriefMsg
                    Challenge$ = Get_CRAM_MD5(Challenge$, Pop3Pwd)
                    TCP_SEND hPop3, Get_Base64_Encode$(Pop3User + " " + Challenge$) + Eol$
                    TCP_LINE hPop3, Buffer
                    CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                    IF LEFT$(Buffer, 1) = "+" THEN
                        Logwrite "POP3 Authentication established", hPop3, %LogState_RasDialResp
                        FUNCTION = %True
                    ELSE
                        Logwrite Buffer, hPop3, %LogState_FatalError
                    END IF
                ELSE
                    Logwrite Buffer, hPop3, %LogState_FatalError
                END IF
        END SELECT
        EXIT FUNCTION
Pop3AuthSaslError:

END FUNCTION


FUNCTION Pop3GetMailBox(BYVAL hPop3 AS LONG, BYVAL Pop3Server AS STRING, BYVAL Pop3User AS STRING, _
                        Messages AS LONG, MsgSize AS LONG, MailAktiv() AS LONG, MailDeleted() AS LONG, _
                        MailMsgId() AS STRING, MailUidl() AS STRING, Maillaenge() AS LONG, _
                        BYVAL Pop3Envelope AS STRING) AS LONG

        LOCAL MsgStart     AS LONG        ' Aktuelle Messagenummer fr Start (Mail halten)
        LOCAL MsgNumber    AS LONG        ' Aktuelle Messagenummer
        LOCAL Temp         AS STRING      '

        MsgStart = 1

        SetThreadPriority pr(hPop3).hThread, %THREAD_PRIORITY_HIGHEST

        IF Pop3GetStat(hPop3, Messages, MsgSize) = %True THEN
            FUNCTION = %True
            IF Messages > 0 THEN
                IF Pop3GetList(hPop3, MailAktiv(), MailLaenge()) = %True THEN
                    ' UIDLs fr Mail halten oder fehlende Message-IDs holen
                    IF Pop3GetUidl(hPop3, MsgStart, Messages, MailUidl()) = %True THEN
                        FOR MsgNumber = MsgStart TO Messages
                            IF Pop3GetTop(hPop3, Pop3Server, Pop3User, MsgNumber, MailAktiv(), MailDeleted(), Pop3Envelope) = %False THEN
                                 EXIT FOR             ' Winsocket Fehler
                                 FUNCTION = %False
                            END IF
                        NEXT MsgNumber
                    ELSE
                        FUNCTION = %False
                    END IF
                ELSE
                    FUNCTION = %False
                END IF
            END IF
        ELSE
            FUNCTION = %False
        END IF

        SetThreadPriority pr(hPop3).hThread, %THREAD_PRIORITY_NORMAL

END FUNCTION

'-------------------------------------------------------------------------------------------
' Pop3, Get the status of the POP3 account
'-------------------------------------------------------------------------------------------
FUNCTION Pop3GetStat(BYVAL hPop3 AS LONG, Messages AS LONG, MsgSize AS LONG) AS LONG

        LOCAL Buffer       AS STRING      ' Rcvd-Buffer

        FUNCTION = %True
        ON ERROR GOTO Pop3GetStatError

        TCP_Send hPop3, "STAT" + Eol$
        TCP_Line hPop3, Buffer
        CpsRcvd = CpsRcvd + LEN(Buffer$) + 2

        IF LEFT$(Buffer, 3) <> "+OK" THEN
            Logwrite "Error on receiving Mailbox Status", hPop3, %LogState_FatalError
            FUNCTION = %False
        ELSE
            Messages = VAL(PARSE$(Buffer, " ", 2))
            MsgSize  = VAL(PARSE$(Buffer, " ", 3))
            Logwrite TRIM$(STR$(Messages)) + " Messages" + " with" + STR$(MsgSize) + " (Bytes)", hPop3, %LogState_TransStat
            FUNCTION = %True
        END IF
        EXIT FUNCTION

Pop3GetStatError:
        FUNCTION = %False
END FUNCTION


'-------------------------------------------------------------------------------------------
' Pop3, Get the List of the POP3 account
'-------------------------------------------------------------------------------------------
FUNCTION Pop3GetList(BYVAL hPop3 AS LONG, MailAktiv() AS LONG, Maillaenge() AS LONG) AS LONG

        LOCAL MsgCurr      AS LONG        ' Nummer der laufenden Message
        LOCAL MsgLen       AS LONG        ' Lnge der aktuellen Message
        LOCAL Buffer       AS STRING      ' Rcvd-Buffer

        FUNCTION = %True
        ON ERROR GOTO Pop3GetListError

        TCP_Send hPop3, "LIST" + Eol$
        TCP_Line hPop3, Buffer
        CpsRcvd = CpsRcvd + LEN(Buffer$) + 2

        IF LEFT$(Buffer, 3) = "+OK" THEN
            DO
                TCP_Line hPop3, Buffer$
                CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                IF Buffer$ <> "." THEN
                    MsgCurr = VAL(PARSE$(Buffer, " ", 1))
                    MsgLen  = VAL(PARSE$(Buffer, " ", 2))
                    MailLaenge(MsgCurr) = MsgLen
                    MailAktiv(MsgCurr)  = %True
                END IF
            LOOP UNTIL Buffer = "."
            FUNCTION = %True
        ELSE
            Logwrite "Error on receiving Mailbox Listing", hPop3, %LogState_TransStat
            FUNCTION = %False
        END IF

        EXIT FUNCTION

Pop3GetListError:
        FUNCTION = %False
END FUNCTION

'-------------------------------------------------------------------------------------------
' Pop3, UIDL Status of the POP3 account
'-------------------------------------------------------------------------------------------
FUNCTION Pop3GetUidl(BYVAL hPop3 AS LONG, MsgStart AS LONG, BYVAL Messages AS LONG, MailUidl() AS STRING) AS LONG

        LOCAL Buffer       AS STRING      ' Rcvd-Buffer
        LOCAL Uidl         AS STRING
        LOCAL MsgCurr      AS LONG        ' Nummer der laufenden Message
        LOCAL Temp         AS STRING
        LOCAL i            AS LONG        '

        FUNCTION = %True
        ON ERROR GOTO Pop3UidlError

        TCP_Send hPop3, "UIDL" + Eol$
        TCP_Line hPop3, Buffer
        CpsRcvd = CpsRcvd + LEN(Buffer$) + 2

        IF LEFT$(Buffer, 3) = "+OK" THEN
            DO
                TCP_Line hPop3, Buffer$
                CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                IF Buffer$ <> "." THEN
                    MsgCurr = VAL(PARSE$(Buffer, " ", 1))
                    Uidl    = PARSE$(Buffer, " ", 2)
                    MailUidl(MsgCurr) = Uidl
                END IF
            LOOP UNTIL Buffer = "."
            FUNCTION = %True
        ELSE
            Temp$ = "Error on receiving Mailbox Informations"
            Logwrite Temp$, hPop3, %LogState_TransStat
            FUNCTION = %False
        END IF

        EXIT FUNCTION

Pop3UidlError:
        FUNCTION = %False
END FUNCTION


'-------------------------------------------------------------------------------------------
' Pop3, UIDL Status of the POP3 account
'-------------------------------------------------------------------------------------------
FUNCTION Pop3GetTop(BYVAL hPop3 AS LONG, BYVAL Pop3Server AS STRING, BYVAL Pop3User AS STRING, BYVAL MsgNumber AS LONG, MailAktiv() AS LONG, MailDeleted() AS LONG, BYVAL Pop3Envelope AS STRING) AS LONG

        LOCAL Buffer       AS STRING      ' allgemeiner Rcvd-Buffer
        LOCAL HdrBuffer    AS STRING      ' enthlt nur die Headerzeilen
        LOCAL HdrLine      AS LONG        ' die aktuelle Zeile im Header
        LOCAL MailTo       AS STRING      ' MailTo: Feld
        LOCAL MailFrom     AS STRING      ' MailFrom: Feld
        LOCAL MailStatus   AS LONG        '
        LOCAL MailHold     AS INTEGER     ' Mail halten %True=Halten, %False=auf Server lschen
        LOCAL MsgId        AS STRING      ' Message-ID fr Dupekill
        LOCAL MsgId_Uidl   AS STRING      ' temporre Message-ID, generiert aus der UIDL
        LOCAL Betreff      AS STRING      ' Subject/Betreff
        LOCAL DupeFound    AS INTEGER     '
        LOCAL Pop3SplFile  AS STRING      ' Pfad/Name des Spoolfile
        LOCAL Pop3MailSize AS LONG        '
        LOCAL CSHeader()   AS STRING      ' Header der Mail
        LOCAL CSZiel       AS STRING      ' Ergebnis des Artikelfilters (CrossSecretary)
        LOCAL RBL          AS STRING      ' RBL-Ergenisse (X-RBL)
        LOCAL ReqAction    AS LONG        '
        LOCAL Position     AS LONG        ' Dummy fr REGEXPR
        LOCAL Result       AS LONG
        LOCAL a            AS STRING      ' Dummy/Temp
        LOCAL i            AS LONG        ' Dummy/Temp
        LOCAL p            AS LONG        ' Dummy/Temp

        LOCAL Pop3Env      AS STRING      ' interne Envelope

        ON ERROR GOTO Pop3GetTopError

        REDIM CSHeader(1000)              ' Array lschen

        FUNCTION        = %True
        MailStatus      = 0               ' 0=Download, 1=Skip, 2=ToLarge, 10=Kill, 20=New Envelope

        'MailHold        = Pop3Keep%       ' Default Option fr 'Mail halten' setzen
        MsgId           = ""              ' leere MessageID
        MsgId_Uidl      = ""              '
        HdrBuffer       = ""              ' Buffer fr Header lschen
        HdrLine         = 0               ' aktuelle Zeile im Header
        ReqAction       = %False          '
        RBL             = ""              ' RBL-Eintrge leeren
        DupeFound       = %False          '
        Pop3Env         = "user@localhost"'
        CSHeader(1)     = ""              ' Header lschen (Trenner als Start einfgen)

        ' Teil 1, mit Top den Header der Message holen und parsen
        a$ = "TOP" & STR$(MsgNumber) & " 0"
        TCP_Send hPop3, a$ + Eol$
        TCP_Line hPop3, Buffer$
        CpsRcvd = CpsRcvd + LEN(Buffer$) + 2

        IF LEFT$(Buffer$, 3) = "+OK" THEN
            Pop3MailSize = VAL(PARSE$(Buffer$, " ", 2))
            DO
                TCP_Line hPop3, Buffer$
                CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                IF Buffer$ <> "." THEN
                    HdrBuffer = HdrBuffer + Buffer$ + Lf$
                    IF LEFT$(Buffer$, 1) = CHR$(9) OR LEFT$(Buffer$, 1) = CHR$(32) THEN
                        REPLACE "        " WITH " " IN Buffer$
                        ' Header ist gefaltet
                        CSHeader(HdrLine&) = CSHeader(HdrLine&)+ MID$(Get_Qp2Text$(Buffer$), 2)
                    ELSE
                        ' normaler Header
                        IF Buffer$ = "" THEN
                            ' teilweisen Header-Trenner skippen
                        ELSE
                            HdrLine& = HdrLine& + 1
                            IF HdrLine& < 1000 THEN
                                 CSHeader(HdrLine&) = Get_Qp2Text$(Buffer$)
                            END IF
                       END IF
                    END IF
                END IF
                ' Mailfrom fr Logfile, Bildausgabe und CrossSecretary holen
                IF INSTR(UCASE$(Buffer$), "FROM:") = 1 THEN
                    MailFrom$ = Get_Qp2Text$(TRIM$(MID$(Buffer$, 6)))
                END IF
                ' evenuell vom Server gesetzte Envelope-To verwenden
'                IF Pop3UseEnvelopeTo% = %True THEN
'                    IF INSTR(UCASE$(Buffer$), "ENVELOPE-TO:") = 1 THEN
'                        Pop3EnvelopeTo$ = TRIM$(MID$(Buffer$, 13))
'                    END IF
'                END IF
                ' Message_ID fr Dupekill holen
                IF INSTR(UCASE$(Buffer$), "MESSAGE-ID:") = 1 THEN
                    MsgId$ = PARSE$(TRIM$(MID$(Buffer$, 12)), " ", 1)
                END IF
            LOOP UNTIL Buffer = "."

            ' Header nochmals wegen "Vertddelter" To/Cc-Zeilen untersuchen
            FOR p& = 1 TO HdrLine
                Buffer$ = CSHeader(p&)
                ' Betreff fr Logfile und Bildausgabe holen
                IF INSTR(UCASE$(Buffer$), "SUBJECT:") = 1 THEN
                    Betreff$ = Get_Qp2Text$(TRIM$(MID$(Buffer$, 9)))
                END IF
                ' MailTo fr Logfile und CrossSecretary holen (eventuell auftddeln)
                IF INSTR(UCASE$(Buffer$), "TO:") = 1 THEN
                    Buffer$ = TRIM$(MID$(Buffer$, 4))
                    i& = PARSECOUNT(Buffer$, ",")
                    IF i& > 1 THEN
                        CSHeader(p&) = "To: " & Get_Qp2Text$(TRIM$(PARSE$(Buffer$, ",", 1)))
                        FOR i& = 2 TO PARSECOUNT(Buffer$, ",")
                            HdrLine& = HdrLine& + 1
                            IF HdrLine& < 1000 THEN
                                CSHeader(HdrLine&) = "To: " & Get_Qp2Text$(TRIM$(PARSE$(Buffer$, ",", i&)))
                            END IF
                        NEXT i&
                    END IF
                END IF
                ' MailCc auftddeln
                IF INSTR(UCASE$(Buffer$), "CC:") = 1 THEN
                    Buffer$ = TRIM$(MID$(Buffer$, 4))
                    i& = PARSECOUNT(Buffer$, ",")
                    IF i& > 1 THEN
                        CSHeader(p&) = "Cc: " & Get_Qp2Text$(TRIM$(PARSE$(Buffer$, ",", 1)))
                        FOR i& = 2 TO PARSECOUNT(Buffer$, ",")
                            HdrLine& = HdrLine& + 1
                            IF HdrLine& < 1000 THEN
                                CSHeader(HdrLine&) = "To: " & Get_Qp2Text$(TRIM$(PARSE$(Buffer$, ",", i&)))
                            END IF
                        NEXT i&
                    END IF
                END IF
            NEXT p&
            ' Headertrenner fr internes CrossSecretary hinzufgen
            CSHeader$(HdrLine& + 1) = ""
        ELSE
            FUNCTION = %False
            Logwrite a$, hPop3, %LogState_OtherError
            Logwrite Buffer$, hPop3, %LogState_OtherError
            EXIT FUNCTION
        END IF

        ' Teil 1a, falls der Server nicht schon beim TOP-Befehl eine Mailgre liefert,
        '          nochmals speziell per LIST nachfragen
        IF Pop3MailSize = 0 THEN
            TCP_SEND hPop3, "LIST" + STR$(MsgNumber) + Eol$
            TCP_LINE hPop3, Buffer$
            CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
            IF LEFT$(Buffer$, 3) = "+OK" THEN
                Pop3MailSize = VAL(PARSE$(Buffer$, " ", 3))
            END IF
        END IF

'            ' Teil 5, Mailgrenbegrenzung
'            IF (Pop3MailSize > Pop3MaxLen) AND MailStatus = 0 AND Pop3MaxLen > 0 THEN
'                MailStatus = 2                ' Mail zu gro, nicht anfassen und Meldung erzeugen
'            END IF


        ' Teil 6a, Relay Blacklist bearbeiten
        FOR p& = 1 TO HdrLine&
            FOR p& = 1 TO HdrLine&
                IF LEFT$(UCASE$(CSHeader(p&)), 9) = "RECEIVED:" THEN
                    IF RBL_ScanReceived(CSHeader(p&), a$) = %True THEN
                        RBL = RBL + "X-RBL: " + a$ + Lf$
                        HdrBuffer = RBL + HdrBuffer
                        INCR HdrLine&
                        CSHeader$(HdrLine&) = "X-RBL: " + a$
                        CSHeader$(HdrLine& + 1) = ""
                    END IF
                END IF
            NEXT p&
        NEXT p&

        ' Teil 6b, CrossSecretary
        ' Pop3EnvelopeTo auf gltigen Syntax checken, damit das interne PM-Zielbrett des
        ' CrossSecretary-Filters nicht unterlaufen wird (z.B. Envelope-To Header knnte
        ' defekt sein, da kein Standard)
        REGEXPR "[a-z0-9._-]+@[a-z0-9._-]+" IN Pop3Envelope$ TO Position&, Result&
        IF Result& = 0 THEN
            Logwrite "Incorrect Envelope-To (" +  Pop3Envelope$ + "), using internal Envelope (" + _
                     Pop3Env$ + ") for internal Filter.", hPop3, %LogState_Normal
                     Pop3Envelope$ = Pop3Env$   ' Default Envelope als Empfnger setzen (fr CS)
        END IF
        Result& = Pop3GetCheck(hPop3, Pop3Server, Pop3User, MailStatus&,  Pop3Envelope$, MailFrom, Betreff, MsgID, "", Pop3MailSize, CSHeader$(), CSZiel, HdrBuffer, RBL$)

        ' Mail normal abholen
        IF MailStatus = 0 THEN
            MailAktiv(MsgNumber) = %True
            MailDeleted(MsgNumber) = %False
        END IF

        ' Teil 8, Mail ignorieren
        IF MailStatus = 1 THEN
            MailAktiv(MsgNumber) = %False
            MailDeleted(MsgNumber) = %False
        END IF

        ' Teil 9, Mail zu gro
        IF MailStatus = 2 THEN
            'Pop3Cmd = "Message" + STR$(MsgNumber) + " too long"
            'INCR Pop3MailFiltered
            'HdrBuffer$ = LEFT$(HdrBuffer$, LEN(HdrBuffer$) - (LEN(Lf$) * 2))
            'HdrBuffer$ = "X-XP-Mode: TopOfMail" + Lf$ + _
            '             "Summary: Message too long, ignored (Original Size:" +_
            '             STR$(Pop3MailSize) + " Byte)" + Lf$ + HdrBuffer$
            'Logwrite "Message to long: " + MsgId + CrLf$ + CHR$(9, 9, 9) + _
            '         " from: " + Get_NC_Adress(MailFrom$) + CrLf$ + CHR$(9, 9, 9) + _
            '         " Subject: " + Betreff$, %Pop3, %LogState_TrivialMsg
            'Result& = Pop3WriteMessage(hPop3, HdrBuffer$)
        END IF

        ' Teil 10, Spam/Filter (Mail konsequent lschen)
        IF MailStatus = 10 THEN
            MailAktiv(MsgNumber) = %False
            IF Pop3GetDele(hPop3, MsgNumber) = %True THEN
                MailDeleted(MsgNumber) = %True
            ELSE
                MailDeleted(MsgNumber) = %False
            END IF
        END IF

        EXIT FUNCTION

Pop3GetTopError:
        FUNCTION = %False
END FUNCTION

'-------------------------------------------------------------------------------------------
' Pop3, Check Message
'-------------------------------------------------------------------------------------------
FUNCTION Pop3GetCheck(BYVAL hPop3 AS LONG, BYVAL Pop3Server AS STRING, BYVAL Pop3User AS STRING, _
                      MailStatus AS LONG, BYVAL Mailto AS STRING, BYVAL MailFrom AS STRING, _
                      BYVAL Betreff AS STRING, BYVAL MsgID AS STRING, BYVAL MsgBezug AS STRING, _
                      BYVAL Pop3MailSize AS LONG, CSHeader() AS STRING, CSZiel AS STRING, _
                      HdrBuffer AS STRING, BYVAL RBL AS STRING) AS LONG

        LOCAL CSReturn     AS LONG        ' Ergebnis des Artikelfilters (%True=etwas gefunden)
        LOCAL CSZeile      AS STRING      ' Die Zeile anhand der gefiltert wurde (CrossSecretary)
        LOCAL CSReason     AS STRING      ' erkannter Filterbegriff
        LOCAL CSSearch     AS STRING      ' Feinsuche mit Infos
        LOCAL CSResult     AS STRING      ' Zielbrett/Ergebnis
        LOCAL RBL_Info     AS STRING      '
        LOCAL Result       AS LONG        '
        LOCAL i            AS LONG        '

        ON ERROR GOTO Pop3GetCheckError

        FUNCTION = %True

        RBL_Info = RBL$

        CSReturn = Pop3GetFilter(Get_XP_Adress(MailTo$), Get_XP_Adress(MailFrom$), Betreff$, MsgID, "", CSHeader(), CSZiel$, CSZeile$)

        SELECT CASE CSReturn
            CASE  0:
            CASE  1: ' (RETR) Message trotz eventuellem Pop3MaxLen holen
                     MailStatus = 0
            CASE  2: ' (SKIP) Message filtern
                     MailStatus = 1
                     INCR Pop3MailFiltered
                     Logwrite "Filter: " + MsgId + CrLf$ + CHR$(9, 9, 9) + _
                              " from: " + Get_NC_Adress(MailFrom$) + CrLf$ + CHR$(9, 9, 9) + _
                              " Subject: " + Betreff$ + CrLf$ + CHR$(9, 9, 9) + _
                              " Reason: " + CSZeile$, hPop3, %LogState_Filter
'            CASE  3: ' (HEAD) nur Header schreiben
'                     MailStatus = 1
'                     INCR Pop3MailFiltered
'                     ' Untersttzung fr Headerbehandlung in XP
'                     HdrBuffer$ = LEFT$(HdrBuffer$, LEN(HdrBuffer$) - (LEN(Lf$) * 2))
'                     HdrBuffer$ = "X-XP-Mode: TopOfMail" + Lf$ + _
'                                  "Summary: Message filtered (Original Size:" +_
'                                  STR$(Pop3MailSize) + " Byte)" + Lf$ + HdrBuffer$
'                     Result& = Pop3WriteMessage(hPop3, HdrBuffer$)
'                     Logwrite "Header: " + MsgId + CrLf$ + CHR$(9, 9, 9) + _
'                              " from: " + Get_NC_Adress(MailFrom$) + CrLf$ + CHR$(9, 9, 9) + _
'                              " Subject: " + Betreff$ + CrLf$ + CHR$(9, 9, 9) + _
'                              " Reason: " + CSZeile$, %Pop3, %LogState_TrivialMsg
            CASE 10: ' (DELE) Mail konsequent lschen
                     MailStatus = 10
                     INCR Pop3MailFiltered
                     INCR Pop3MailKilled
                     Logwrite "Killing: " + MsgId + CrLf$ + CHR$(9, 9, 9) + _
                              " from: " + Get_NC_Adress(MailFrom$) + CrLf$ + CHR$(9, 9, 9) + _
                              " Subject: " + Betreff$ + CrLf$ + CHR$(9, 9, 9) + _
                              " Reason: " + CSZeile$, hPop3, %LogState_Filter
                     ' CrossSecretary-Mail vorbereiten
                     Pop3KillPrepare CSZeile$, CSReason$, CSSearch$, CSResult$, RBL_Info
                     Pop3KillLogAdd hPop3, Pop3Server, Pop3User, Mailfrom, MailTo, Betreff, MsgId, Pop3MailSize, CSHeader(), CSReason, CSSearch, CSResult, RBL_Info
                     MediaPlay "PLONK.WAV"
            'CASE 20: ' (Envelope) Mail wird umadressiert
            '         Pop3EnvelopeTo$ = CSZiel$
        END SELECT
        FUNCTION = %True
        EXIT FUNCTION

Pop3GetCheckError:
        FUNCTION = %False
END FUNCTION

'-------------------------------------------------------------------------------------------
' Pop3, Message filtern
'-------------------------------------------------------------------------------------------
FUNCTION Pop3GetFilter(BYVAL Mailto AS STRING, BYVAL MailFrom AS STRING, BYVAL Betreff AS STRING, BYVAL MsgID AS STRING, BYVAL MsgBezug AS STRING, CSHeader() AS STRING, CSZiel AS STRING, CSZeile AS STRING) AS LONG

        LOCAL CS           AS CS_Data     ' CrossSecretary: Strukturen
        LOCAL CSBrett      AS STRING      ' Newsgroup in ZC/CS Style gewandelt
        LOCAL CSEnvelope   AS STRING      ' beinhaltet das letzte gefundene Ziel-Brett
        LOCAL LastBrett    AS STRING
        LOCAL FilterDatei  AS INTEGER

        DIM Kriterien(10)  AS STRING      '

        ON ERROR GOTO Pop3GetFilterError

        FUNCTION = 0                      ' 1=Download, 2=Skip, 3=Head, 10=Kill, 20=New Envelope

        CS.BrettPos&   = 1                ' Defaultwerte damit CS an der ersten Zeile
        CS.KritPos&    = 0                ' zu filtern beginnt. Die letzte gefundene
        CS.ReturnFlag& = 0                ' Zeile ist der endgltige Wert
        CSEnvelope$    = ""               '

        DO
            CALL CS_Filter (MailTo$, MailFrom$, Betreff$, MsgBezug$, CSZeile$, MsgId$, CSHeader(), _
                        Kriterien$(), CSZiel$, LastBrett$, FilterCfg$(), VARPTR(CS))
            IF CS.ReturnFlag& = 1 THEN
                'PRINT "Mailfrom     :"; Mailfrom$
                'PRINT "Mailto       :"; MailTo
                'PRINT "Betreff      :"; Betreff$
                'PRINT "Optionen     :"; Optionen&
                'PRINT "Zeile$       :"; Zeile$
                'PRINT "Ergebnis     :"; ">>" + CSZiel$ + "<<"
                'WAITKEY$
                CSZiel$ = TRIM$(CSZiel$)
                SELECT CASE CSZiel$
                    CASE "RETR"
                        FUNCTION = 1      ' Mail immer holen (ignoriert Pop3MaxLen!)
                    CASE "SKIP"
                        FUNCTION = 2      ' Mail berspringen
                    CASE "HEAD"
                        FUNCTION = 0      ' ignorieren
                    CASE "DELE"
                        FUNCTION = 10     ' Mail konsequent lschen
                    CASE ELSE
                END SELECT                '
                'WAITKEY$
            ELSE
            END IF
        LOOP WHILE CS.ReturnFlag& = 1 AND (CS.Optionen& AND 16384) = 0
        EXIT FUNCTION                     '

Pop3GetFilterError:
        FUNCTION = 0
END FUNCTION

'-------------------------------------------------------------------------------------------
' Pop3, Message lschen
'-------------------------------------------------------------------------------------------
FUNCTION Pop3GetDele(BYVAL hPop3 AS LONG, BYVAL MsgNumber AS LONG) AS LONG

        LOCAL Buffer       AS STRING      ' allgemeiner Rcvd-Buffer
        LOCAL Result       AS LONG        '

        ON ERROR RESUME NEXT

        Logwrite "Deleting Message" + STR$(MsgNumber), hPop3, %LogState_Debug
        TCP_Send hPop3,"DELE" + STR$(MsgNumber) + Eol$
        TCP_Line hPop3, Buffer
        Logwrite Buffer, hPop3, %LogState_Debug
        IF LEFT$(Buffer$, 3) = "+OK" THEN
            FUNCTION = %True
        ELSE
            FUNCTION = %False
        END IF

END FUNCTION

'-------------------------------------------------------------------------------------------
' Pop3, TOP-Befehl durchreichen
'-------------------------------------------------------------------------------------------
FUNCTION Pop3TransferTop(BYVAL Arg AS STRING, BYVAL hIntern AS LONG, BYVAL hExtern AS LONG, BYVAL Messages AS LONG, BYVAL MsgCount AS LONG, MailAktiv() AS LONG, MailDeleted() AS LONG, MailLaenge() AS LONG, BYVAL Mailfilter AS LONG) AS LONG

        LOCAL n            AS LONG
        LOCAL i            AS LONG        '
        LOCAL c            AS LONG
        LOCAL Buffer       AS STRING      '

        IF LEN(Arg$) THEN
            n = VAL(Arg$)
            IF MsgCount <= 0 OR n > MsgCount OR n = 0 THEN
                TCP_Print hIntern, MsgNoSuch + " Arg"
            ELSE
                c& = 0
                FOR i& = 1 TO Messages
                    IF MailAktiv(i&) = %True THEN
                        c& = c& + 1
                        IF n = c THEN
                            IF MailDeleted&(i&) = %False THEN
                                IF i& = Messages AND Mailfilter > 0 THEN
                                    ' Header der internen Reportmail anzeigen
                                    TCP_Print hIntern, "+OK" + STR$(Maillaenge(i&)) + " octets" + " (internal spam-message)"
                                    TCP_Print hIntern, Pop3KillTop(hExtern)
                                    TCP_Print hIntern, "."
                                ELSE
                                    TCP_Print hExtern, "TOP" + STR$(i&) + " 0"
                                    TCP_Line hExtern, Buffer$
                                    IF LEFT$(Buffer$, 3) = "+OK" THEN
                                        TCP_Print hIntern, "+OK" + STR$(Maillaenge(i&)) + " octets"
                                        TCP_Copy hExtern, hIntern
                                    ELSE
                                        TCP_Print hIntern, MsgNoSuch
                                    END IF
                                END IF
                            ELSE
                                TCP_Print hIntern, MsgNoSuch
                            END IF
                        END IF
                    END IF
                NEXT i&
            END IF
        ELSE
            TCP_Print hIntern, MsgCmdUnknown
        END IF

END FUNCTION

'-------------------------------------------------------------------------------------------
' Pop3, RETR-Befehl durchreichen
'-------------------------------------------------------------------------------------------
FUNCTION Pop3TransferRetr(BYVAL Arg AS STRING, BYVAL hIntern AS LONG, BYVAL hExtern AS LONG, BYVAL Messages AS LONG, BYVAL MsgCount AS LONG, MailAktiv() AS LONG, MailDeleted() AS LONG, Maillaenge() AS LONG, BYVAL Mailfilter AS LONG) AS LONG

        LOCAL n            AS LONG
        LOCAL i            AS LONG        '
        LOCAL c            AS LONG
        LOCAL Buffer       AS STRING      '

        IF LEN(Arg$) THEN
            n = VAL(Arg$)
            IF MsgCount <= 0 OR n > MsgCount OR n = 0 THEN
                TCP_Print hIntern,"-ERR no such message"
            ELSE
                c& = 0
                SetThreadPriority pr(hIntern).hThread, %THREAD_PRIORITY_HIGHEST
                FOR i& = 1 TO Messages
                    IF MailAktiv(i&) = %True THEN
                        c& = c& + 1
                        IF n = c THEN
                            IF MailDeleted&(i&) = %False THEN
                                IF i& = Messages AND Mailfilter > 0 THEN
                                    ' interne Reportmail anzeigen
                                    TCP_Print hIntern, "+OK" + STR$(Maillaenge(i&)) + " octets" + " (internal spam-message)"
                                    TCP_Print hIntern, Pop3KillMsg(hExtern)
                                    TCP_Print hIntern, "."
                                ELSE
                                    TCP_Print hExtern, "RETR" + STR$(i&)
                                    TCP_Line hExtern, Buffer$
                                    IF LEFT$(Buffer$, 3) = "+OK" THEN
                                        TCP_Print hIntern, "+OK" + STR$(Maillaenge(i&)) + " octets"
                                        TCP_Copy hExtern, hIntern
                                    ELSE
                                        TCP_Print hIntern, MsgNoSuch
                                    END IF
                                END IF
                            ELSE
                                TCP_Print hIntern, MsgNoSuch
                            END IF
                        END IF
                    END IF
                NEXT i&
                SetThreadPriority pr(hIntern).hThread, %THREAD_PRIORITY_NORMAL
            END IF
        ELSE
            TCP_Print hIntern, MsgCmdUnknown
        END IF

END FUNCTION


'-------------------------------------------------------------------------------------------
' Pop3, DELE-Befehl durchreichen
'-------------------------------------------------------------------------------------------
FUNCTION Pop3TransferDele(BYVAL Arg AS STRING, BYVAL hIntern AS LONG, BYVAL hExtern AS LONG, BYVAL Messages AS LONG, BYVAL MsgCount AS LONG, MsgNew AS LONG, MsgSizeNew AS LONG, MailAktiv() AS LONG, MailDeleted() AS LONG, MailLaenge() AS LONG, BYVAL  _
Mailfilter AS LONG) AS LONG

        LOCAL n            AS LONG
        LOCAL i            AS LONG        '
        LOCAL c            AS LONG
        LOCAL Buffer       AS STRING      '

        IF LEN(Arg$) THEN
            n = VAL(Arg$)
            IF MsgCount <= 0 OR n > MsgCount OR n = 0 THEN
                TCP_Print hIntern, MsgNoSuch
            ELSE
                c& = 0
                FOR i& = 1 TO Messages
                    IF MailAktiv(i&) = %True THEN
                        c& = c& + 1
                        IF n = c THEN
                            IF MailDeleted(i&) = %False THEN
                                IF i& = Messages AND Mailfilter > 0 THEN
                                    ' interne Reportmail lschen
                                    TCP_Print hIntern, "+OK internal spam-message deleted"
                                    MailDeleted(i&) = %True
                                    MsgSizeNew = MsgSizeNew - MailLaenge(i&)
                                    DECR MsgNew
                                ELSE
                                    TCP_Print hExtern, "DELE" + STR$(i&)
                                    TCP_Line hExtern, Buffer$
                                    IF LEFT$(Buffer$, 3) = "+OK" THEN
                                        TCP_Print hIntern, "+OK message" + STR$(c&) + " deleted"
                                        MailDeleted(c&) = %True
                                        MsgSizeNew = MsgSizeNew - MailLaenge(i&)
                                        DECR MsgNew
                                    ELSE
                                        TCP_Print hIntern, MsgNoSuch
                                    END IF
                                END IF
                            ELSE
                                TCP_Print hIntern, MsgNoSuch
                            END IF
                        END IF
                    END IF
                NEXT i&
            END IF
        ELSE
            TCP_Print hIntern, MsgCmdUnknown
        END IF

END FUNCTION

'-------------------------------------------------------------------------------------------
' Pop3, LIST-Befehl intern ausfhren
'-------------------------------------------------------------------------------------------
FUNCTION Pop3PutList(BYVAL Arg AS STRING, BYVAL hIntern AS LONG, BYVAL Messages AS LONG, BYVAL MsgCount AS LONG, BYVAL MsgNew AS LONG, MailAktiv() AS LONG, MailDeleted() AS LONG, MailLaenge() AS LONG) AS LONG

        LOCAL n            AS LONG
        LOCAL i            AS LONG        '
        LOCAL c            AS LONG
        LOCAL Buffer       AS STRING      '

        IF LEN(Arg$) THEN
            ' spezielle Message suchen
            n = VAL(Arg$)
            IF MsgCount <= 0 OR n > MsgCount OR n = 0 THEN
                TCP_Print hIntern, MsgNoSuch
            ELSE
                c& = 0
                FOR i& = 1 TO Messages
                    IF MailAktiv(i&) = %True THEN
                        c& = c& + 1
                        IF n = c THEN
                            IF MailDeleted&(i&) = %False THEN
                                TCP_Print hIntern, "+OK" + STR$(c&) + STR$(Maillaenge(i&))
                            ELSE
                                TCP_Print hIntern, MsgNoSuch
                            END IF
                        END IF
                    END IF
                NEXT i&
            END IF
        ELSE
            ' allgemeines LIST
            TCP_Print hIntern, "+OK" + STR$(MsgNew) + " messages follows"
            c& = 0
            FOR i& = 1 TO Messages
                IF MailAktiv(i&) = %True THEN
                     c& = c& + 1
                     IF MailDeleted(i&) = %False THEN
                        TCP_Print hIntern, TRIM$(STR$(c&)) + STR$(Maillaenge(i&))
                    END IF
                END IF
            NEXT i&
            TCP_Print hIntern, "."
        END IF

END FUNCTION

'-------------------------------------------------------------------------------------------
' Pop3, UIDL-Befehl intern ausfhren
'-------------------------------------------------------------------------------------------
FUNCTION Pop3PutUidl(BYVAL Arg AS STRING, BYVAL hIntern AS LONG, BYVAL Messages AS LONG, BYVAL MsgCount AS LONG, BYVAL MsgNew AS LONG, MailAktiv() AS LONG, MailDeleted() AS LONG, MailUidl() AS STRING) AS LONG

        LOCAL n            AS LONG
        LOCAL i            AS LONG        '
        LOCAL c            AS LONG
        LOCAL Buffer       AS STRING      '

        IF LEN(Arg$) THEN
            n = VAL(Arg$)
            IF MsgCount <= 0 OR n > MsgCount OR n = 0 THEN
                TCP_Print hIntern, MsgNoSuch
            ELSE
                c& = 0
                FOR i& = 1 TO Messages
                    IF MailAktiv(i&) = %True THEN
                        c& = c& + 1
                        IF n = c THEN
                             IF MailDeleted(i&) = %False THEN
                                 TCP_Print hIntern, "+OK" + STR$(c&) + " " + MailUidl(i&)
                             ELSE
                                 TCP_Print hIntern, MsgNoSuch
                             END IF
                        END IF
                    END IF
                NEXT c&
            END IF
        ELSE
            TCP_Print hIntern, "+OK" + STR$(MsgNew) + " uidl follows"
            c& = 0
            FOR i& = 1 TO Messages
                IF MailAktiv(i&) = %True THEN
                    c& = c& + 1
                    IF MailDeleted(i&) = %False THEN
                        TCP_Print hIntern, TRIM$(STR$(c&)) + " " + MailUidl(i&)
                    END IF
                END IF
            NEXT i&
            TCP_Print hIntern, "."
        END IF

END FUNCTION


'-------------------------------------------------------------------------------------------
' Pop3, Daten fr "Killed Messages" aufbereiten
'-------------------------------------------------------------------------------------------
FUNCTION Pop3KillPrepare(CSZeile AS STRING, CSReason AS STRING, CSSearch AS STRING, CSResult AS STRING, RBL_Info AS STRING) AS LONG

        LOCAL RBL_Temp     AS STRING      '
        LOCAL CSTemp       AS STRING      '
        LOCAL CSInfo       AS STRING      '
        LOCAL CSChar       AS STRING      '
        LOCAL CSMode       AS LONG        '
        LOCAL i            AS LONG        '

        CSMode&   = 0
        RBL_Temp  = ""

        ' RBL-Header String fr KillReport aufbearbeiten
        FOR i = 1 TO PARSECOUNT(RBL_Info, Lf$) - 1
             IF i = 1 THEN
                 RBL_Temp = PARSE$(RBL_Info, Lf$, 1)
             ELSE
                 RBL_Temp = RBL_Temp + Lf$ + SPACE$(13) + PARSE$(RBL_Info, Lf$, i)
             END IF
        NEXT i
        RBL_Info = RBL_Temp

        ' erkannter Match parsen
        i& = INSTR(CSZeile$, "")
        CSReason$ = LEFT$(CSZeile$, i& - 2)

        ' Zielbrett parsen
        i& = INSTR(CSZeile$, "")
        CSResult$ = MID$(CSZeile$, i& + 1)

        ' Suche/Feinsuche/Extra-Suche optisch aufbereiten
        i& = INSTR(CSZeile$, "")
        CSSearch$ = MID$(CSZeile$, i& + 1)
        CSSearch$ = PARSE$(CSSearch$, " ", 1)
        FOR i& = 1 TO LEN(CSSearch$)
            CSChar$ = MID$(CSSearch$, i&, 1)
            IF CSChar$ = CHR$(34) THEN
                BIT TOGGLE CSMode&, 0
            ELSE
                IF CSMode& = 0 THEN
                    CSTemp$ = CSTemp$ + CSChar$
                ELSE
                    CSInfo$ = CSInfo$ + CSChar$
                END IF
            END IF
        NEXT i&

        CSSearch$ = CSTemp$
        CSTemp$   = ""
        REPLACE ":" WITH " " IN CSInfo$

        IF INSTR(CSSearch$, "n") > 0 THEN
            CSInfo$ = CSInfo$ + "From "
        END IF
        IF INSTR(CSSearch$, "b") > 0 THEN
            CSInfo$ = CSInfo$ + "Envelope-To "
        END IF
        IF INSTR(CSSearch$, "s") > 0 THEN
            CSInfo$ = CSInfo$ + "Subject "
        END IF
        IF INSTR(CSSearch$, "x") > 0 THEN
            CSInfo$ = CSInfo$ + "Invers-Mode "
        END IF
        IF INSTR(CSSearch$, "c") > 0 THEN
            CSInfo$ = CSInfo$ + "Casesensitiv "
        END IF
        IF INSTR(CSSearch$, "q") > 0 THEN
            CSInfo$ = CSInfo$ + "Quit "
        END IF

        CSInfo$ = TRIM$(CSInfo$)

        CSSearch$ = CSSearch$ + " - " + CSInfo$

END FUNCTION

'-------------------------------------------------------------------------------------------
' Pop3, Message fr "Killed Messages" zusammenstellen
'-------------------------------------------------------------------------------------------
FUNCTION Pop3KillLogAdd(BYVAL hPop3 AS LONG, BYVAL Pop3Server AS STRING, BYVAL Pop3User AS STRING, _
                        BYVAL Mailfrom AS STRING, BYVAL MailTo AS STRING, BYVAL Betreff AS STRING, _
                        BYVAL MsgId AS STRING, BYVAL Pop3MailSize AS LONG,  CSHeader() AS STRING, _
                        BYVAL CSReason AS STRING, BYVAL CSSearch AS STRING, BYVAL CSResult AS STRING, _
                        BYVAL RBL_Info AS STRING) AS LONG

        LOCAL i            AS LONG        '

'        Pop3KillMsg$ = Pop3KillMsg$ + _
'                       "Account    : " + Pop3Server$ + " / " + Pop3User$ + Lf$ + _
'                       Lf$ + _
'                       "Envelope-To: " + Mailto$ + Lf$
        FOR i& = 1 TO UBOUND(CSHeader$)
            IF LEFT$(UCASE$(CSHeader$(i&)), 3) = "TO:" THEN
                Pop3KillMsg$(hPop3) = Pop3KillMsg$(hPop3) + "To         : " +_
                TRIM$(MID$(CSHeader$(i&), 4)) + Lf$
            END IF
        NEXT i&
        Pop3KillMsg$(hPop3) = Pop3KillMsg$(hPop3) + _
                              "From       : " + Get_NC_Adress(MailFrom$) + Lf$ + _
                              "Subject    : " + Betreff$ + Lf$ + _
                              "Message-ID : " + MsgId$ + Lf$ + _
                              "Size       :" + STR$(Pop3MailSize) + " Bytes" + Lf$ + _
                              Lf$ + _
                              "RBL Info   : " + RBL_Info$ + Lf$ + _
                              Lf$ + _
                              "Reason     : " + CSReason$ + Lf$ + _
                              "Search in  : " + CSSearch$ + Lf$ + _
                              "Result     : " + CSResult$ + Lf$ + _
                              Lf$ + _
                              STRING$(70, "-") + Lf$ + _
                              Lf$

END FUNCTION


'-------------------------------------------------------------------------------------------
' Pop3, Message fr "Killed Messages"
'-------------------------------------------------------------------------------------------
FUNCTION Pop3KillLog(BYVAL hPop3 AS LONG) AS LONG

        IF LEN(Pop3KillMsg$(hPop3)) > 0 THEN
            Pop3KillMsg(hPop3) = "To: " + KillReport$ + Lf$ + _
                                 "From: spamproxy@localhost (SpamProxy " + Version$ + ")" + Lf$ + _
                                 "Subject: Killed Messages" + Lf$ + _
                                 "Message-ID: " + TRIM$(STR$(TIMER)) + DATE$ + "@local.spamproxy" + Lf$ + _
                                 Get_Dateheader + Lf$ + _
                                 "X-Mailer: SpamProxy " + Version$ + Lf$ + _
                                 Lf$ + Lf$ + _
                                 "The following message(s) has been killed directly on the Pop3-Server:" + Lf$ + _
                                 Lf$ + _
                                 Lf$ + _
                                 STRING$(70, "-") + Lf$ + _
                                 Lf$ + _
                                 Pop3KillMsg$(hPop3)
        END IF

END FUNCTION


'-------------------------------------------------------------------------------------------
' Pop3, Top-Header fr "Killed Messages"
'-------------------------------------------------------------------------------------------
FUNCTION Pop3KillTop(BYVAL hPop3 AS LONG) AS STRING

        LOCAL i            AS LONG        '

        IF LEN(Pop3KillMsg$(hPop3)) > 0 THEN
            i& = INSTR(Pop3KillMsg(hPop3), Lf$+Lf$)
            FUNCTION = LEFT$(Pop3KillMsg(hPop3), i&)
        END IF

END FUNCTION

'-------------------------------------------------------------------------------------------
' Pop3, HELP Befehl intern ausfhren
'-------------------------------------------------------------------------------------------
FUNCTION Pop3PutHelp(BYVAL hIntern AS LONG) AS LONG

        TCP_Print hIntern, "+OK implemented SpamProxy commands follow:"
        TCP_Print hIntern, "    dele Number"
        TCP_Print hIntern, "    help"
        TCP_Print hIntern, "    list [Number]"
        TCP_Print hIntern, "    pass Pasword"
        TCP_Print hIntern, "    quit"
        TCP_Print hIntern, "    retr Number"
        TCP_Print hIntern, "    rset"
        TCP_Print hIntern, "    stat"
        TCP_Print hIntern, "    top Number"
        TCP_Print hIntern, "    uidl [Number]"
        TCP_Print hIntern, "    user Username"
        TCP_Print hIntern, "."

END FUNCTION


FUNCTION Pop3Listen(BYVAL Pop3Port AS LONG) AS LONG

        LOCAL Result       AS WORD        '
        LOCAL wDat         AS WSAdata
        LOCAL Sockin       AS Sockaddr_In
        LOCAL s            AS LONG
        LOCAL ns           AS LONG        '
        LOCAL sIP          AS ASCIIZ PTR  ' String in Dot-Notation "0.0.0.0"
        LOCAL In_Address   AS In_Addr     '
        LOCAL n            AS LONG
        LOCAL i            AS LONG        '
        LOCAL Temp         AS STRING      '

        s = socket( %PF_INET, %SOCK_STREAM, %IPPROTO_TCP )
        IF s = - 1 THEN
            INCR Errorflag
            'STDOUT "ERR0001"
            EXIT FUNCTION
        END IF
        hlisten = s

        Sockin.sin_family = %AF_INET
        Sockin.sin_port = htons(Pop3Port)
        Sockin.sin_addr.s = CHR$(0, 0, 0, 0)
        n& = bind(s, Sockin, SIZEOF(Sockin))
        IF n& = - 1 THEN
            LogWrite "Another program is using Port" + STR$(Pop3Port), -1, %LogState_FatalError
            CloseSocket s
            FUNCTION = -1
        ELSE
            n& = listen(s, 5)
            IF n& = - 1 THEN
                Logwrite "Pop3 Listen-Error on Port" + STR$(Pop3Port), -1, %LogState_FatalError
                Closesocket s
                FUNCTION = -1
                EXIT FUNCTION
            END IF
            ' am Port lauschen ...
            Logwrite "Pop3-Listen at Port" + STR$(Pop3Port), -1, %LogState_Routing
            DO
                ns = aACCEPT(s, Sockin, SIZEOF(Sockin))
                Logwrite "Accept incoming Pop3-connection ...", -1, %LogState_Debug
                IF ns = - 1 THEN
                     LogWrite "Pop3 Accept-Error on Port" + STR$(Pop3Port), -1, %LogState_OtherError
                     ITERATE DO
                END IF
                In_Address = Sockin.Sin_addr

                ' LONG in IP-String umwandeln
                sIP = Inet_ntoa(in_address.s_addr)

                ' freien Datensatz suchen und reservieren
                i& = TCP_Freefile
                ' Informationen in Datensatz schreiben
                pr(i&).hSocket       = ns
                pr(i&).ip            = in_address.s_addr
                pr(i&).Portnummer    = Pop3Port
                pr(i&).User          = ""
                pr(i&).SocketTimeout = Pop3TimeOut
                pr(i&).SocketError   = %False

                ' Check fr die IP ein Zugriff erlaubt ist
                IF IP_Access(in_address.s_addr) = %True THEN
                    IF i& => %Threads THEN
                        LogWrite STR$(i&)+ " Too many sessions!", -1, %LogState_OtherError
                        TCP_Close i&
                        ITERATE DO
                    ELSE
                        'STDOUT "#" + TRIM$(STR$(i&)) + " ns:" + TRIM$(STR$(ns)) + "  " + DATE$ + " " + TIME$ + "    ";
                        Temp$ = "Incoming Pop3-connection from '" + @sIP + "'  Port:" + STR$(pr(i).Portnummer)
                        Logwrite Temp$, i&, %LogState_SessionInfo
                        THREAD CREATE POP3Incoming(i&) TO pr(i&).hThread
                        IF pr(i&).hThread <= 0 THEN
                            TCP_Close i&
                            LogWrite "Starting Pop3-Thread failed! ("+TRIM$(STR$(i))+")", i&, %LogState_OtherError
                            TCP_Freehandle i&       ' Thread-Datensatz wieder freigeben
                        END IF
                    END IF
                ELSE
                    TCP_Print i&, "+ERR permission denied, closing connection ..."
                    TCP_Close i&
                    TCP_Freehandle i&
                    Temp$ = "Denied Pop3-connection from '" + @sIP + "'  Port:" + STR$(pr(i).Portnummer)
                    Logwrite Temp$, i&, %LogState_SessionInfo
                END IF
            LOOP
        END IF
END FUNCTION

'-------------------------------------------------------------------------------------------
' Smtp, Zeilenweise auslesen aus den Spoolfiles (egal ob Unix/MS-DOS Style Crlf)
'       HighSpeed-Routine
'-------------------------------------------------------------------------------------------
FUNCTION SmtpNextLine(BYVAL SmtpSplHdl AS LONG, LineCount AS LONG, eoFile AS LONG) AS STRING

        STATIC SmtpSplLen  AS LONG        ' Die Lnge des restlichen Spoolfiles
        STATIC Buffer      AS STRING
        LOCAL  BufferNew   AS STRING
        LOCAL  BufferSize  AS LONG
        LOCAL  LineEnd     AS INTEGER
        LOCAL  LineInput   AS STRING

        BufferSize& = 4096

        ON ERROR GOTO SmtpNextLineError

        IF SEEK(SmtpSplHdl) = 1 THEN      ' Zeiger auf Anfang und Init
            SmtpSplLen& = LOF(SmtpSplHdl)
            eoFile& = %False
            Buffer = ""
        END IF

        DO
            LineEnd% = INSTR(Buffer$, Lf$)
            IF LineEnd% > 0 THEN
                FUNCTION = REMOVE$(LEFT$(Buffer$, LineEnd% - 1), CHR$(13))
                Buffer$ = MID$(Buffer$, LineEnd% + 1)
                LineCount& = LineCount& + 1
            ELSE
                IF SmtpSplLen& > 0 THEN
                    IF SmtpSplLen& < BufferSize& THEN
                        BufferSize& = SmtpSplLen&
                    END IF
                    GET$ #SmtpSplHdl, BufferSize&, BufferNew$
                    Buffer$ = Buffer$ + BufferNew$
                    SmtpSplLen& = SmtpSplLen& - BufferSize&
                ELSE
                    FUNCTION = ""
                    eofile& = %True
                END IF
            END IF
            IF SmtpSplLen& = 0 AND Buffer$ = "" THEN
                eoFile& = %True
            END IF
        LOOP WHILE LineEnd% = 0 AND eoFile& = %False

        EXIT FUNCTION

SmtpNextLineError:
        eoFile& = %True
        'Logwrite "Error: parsing Spoolfile", -1, %LogState_OtherError
END FUNCTION

FUNCTION NntpListen(BYVAL NntpPort AS LONG) AS LONG

        LOCAL Result       AS WORD        '
        LOCAL wDat         AS WSAdata
        LOCAL Sockin       AS Sockaddr_In
        LOCAL s            AS LONG
        LOCAL ns           AS LONG        '
        LOCAL sIP          AS ASCIIZ PTR  ' String in Dot-Notation "0.0.0.0"
        LOCAL In_Address   AS In_Addr     '
        LOCAL n            AS LONG
        LOCAL i            AS LONG        '
        LOCAL Temp         AS STRING      '

        s = socket( %PF_INET, %SOCK_STREAM, %IPPROTO_TCP )
        IF s = - 1 THEN
            INCR Errorflag
            'STDOUT "ERR0001"
            EXIT FUNCTION
        END IF
        hlisten = s

        Sockin.sin_family = %AF_INET
        Sockin.sin_port = htons(NntpPort)
        Sockin.sin_addr.s = CHR$(0, 0, 0, 0)
        n& = bind(s, Sockin, SIZEOF(Sockin))
        IF n& = - 1 THEN
            LogWrite "Another program is using Port" + STR$(NntpPort), -1, %LogState_FatalError
            CloseSocket s
            FUNCTION = -1
        ELSE
            n& = listen(s, 5)
            IF n& = - 1 THEN
                Logwrite "Nntp Listen-Error on Port" + STR$(NntpPort), -1, %LogState_FatalError
                Closesocket s
                FUNCTION=-1
                EXIT FUNCTION
            END IF
            ' am Port lauschen ...
            Logwrite "Nntp-Listen at Port" + STR$(NntpPort), -1, %LogState_Routing
            DO
                ns = aACCEPT(s, Sockin, SIZEOF(Sockin))
                Logwrite "Accept incoming Nntp-connection ...", -1, %LogState_Debug
                IF ns = - 1 THEN
                     LogWrite "Nntp Accept-Error on Port" + STR$(NntpPort), -1, %LogState_OtherError
                     ITERATE DO
                END IF
                In_Address = Sockin.Sin_addr

                ' LONG in IP-String umwandeln
                sIP = Inet_ntoa(in_address.s_addr)

                ' freien Datensatz suchen und reservieren
                i& = TCP_Freefile
                ' Informationen in Datensatz schreiben
                pr(i&).hSocket       = ns
                pr(i&).ip            = in_address.s_addr
                pr(i&).Portnummer    = NntpPort
                pr(i&).User          = ""
                pr(i&).SocketTimeout = NntpTimeOut
                pr(i&).SocketError   = %False

                ' Check fr die IP ein Zugriff erlaubt ist
                IF IP_Access(in_address.s_addr) = %True THEN
                    IF i& => %Threads THEN
                        LogWrite STR$(i&)+ " Too many sessions!", -1, %LogState_OtherError
                        TCP_Close i&
                        ITERATE DO
                    ELSE
                        'STDOUT "#" + TRIM$(STR$(i&)) + " ns:" + TRIM$(STR$(ns)) + "  " + DATE$ + " " + TIME$ + "    ";
                        Temp$ = "Incoming Nntp-connection from '" + @sIP + "'  Port:" + STR$(pr(i).Portnummer)
                        Logwrite Temp$, i&, %LogState_SessionInfo
                        THREAD CREATE NNTPIncoming(i&) TO pr(i&).hThread
                        IF pr(i&).hThread <= 0 THEN
                            TCP_Close i&
                            LogWrite "Starting Nntp-Thread failed! ("+TRIM$(STR$(i))+")", i&, %LogState_OtherError
                            TCP_Freehandle i&       ' Thread-Datensatz wieder freigeben
                        END IF
                    END IF
                ELSE
                    TCP_Print i&, "502 permission denied, closing connection ..."
                    TCP_Close i&
                    TCP_Freehandle i&
                    Temp$ = "Denied Nntp-connection from '" + @sIP + "'  Port:" + STR$(pr(i).Portnummer)
                    Logwrite Temp$, i&, %LogState_SessionInfo
                END IF
            LOOP
        END IF
END FUNCTION

FUNCTION NntpIncoming(BYVAL hIntern AS LONG) AS LONG

        LOCAL Buffer       AS STRING      '
        LOCAL Cmd          AS STRING      '
        LOCAL NntpServer   AS STRING
        LOCAL NntpUser     AS STRING      '
        LOCAL NntpPass     AS STRING      '
        LOCAL Newsgroup    AS STRING      '
        LOCAL hExtern      AS LONG        ' Outgoing Socket-Handle

        LOCAL i            AS LONG        '
        LOCAL Arg          AS STRING
        LOCAL Msg          AS LONG
        LOCAL Result       AS LONG

        TCP_Print hIntern, "200 NNTP-SpamProxy " + Version$ + " Server #" + _
                          TRIM$(STR$(hIntern))+ " ready, (c) by Thomas Gohel"

        Result& = NntpIncomingLogin(hIntern, hExtern, NntpServer, NntpUser, NntpPass)

        IF Result& = 0 THEN
            DO
                TCP_Line hIntern, Buffer$

                IF pr(hIntern).SocketError = %True THEN
                    LogWrite "Socket #" + TRIM$(STR$(hIntern))+ " closed by remote host!", hIntern, %LogState_Normal
                END IF
                IF pr(hExtern).SocketError = %True THEN
                    LogWrite "Socket #" + TRIM$(STR$(hExtern))+ " closed by remote host!", hExtern, %LogState_Normal
                END IF

                Cmd$ = UCASE$(PARSE$(Buffer$, " ", 1))
                Arg$ = PARSE$(Buffer$, " ", 2)

                SELECT CASE Cmd$
                    CASE "AUTHINFO"
                        SELECT CASE UCASE$(Arg$)
                            CASE "USER"
                                TCP_Print hIntern, "381 ignored"
                            CASE "PASS"
                                TCP_Print hIntern, "281 ignored"
                        END SELECT
                    CASE "QUIT"
                        TCP_Print hExtern,"QUIT"
                        TCP_Line hExtern, Buffer$
                    CASE "GROUP"
                       TCP_Print hExtern, Buffer$
                       TCP_Line hExtern, Buffer$
                       IF LEFT$(Buffer$, 3) = "211" THEN
                           Newsgroup$ = PARSE$(Buffer$, " ", 5)
                       END IF
                       TCP_Print hIntern, Buffer$
                    '
                    CASE "POST"
                        TCP_Print hExtern, Buffer$
                        TCP_Line hExtern, Buffer$
                        TCP_Print hIntern, Buffer$
                        IF LEFT$(Buffer$, 3)= "340" THEN
                            ' und Posten durchreichen
                            TCP_Copy hIntern, hExtern
                            TCP_Line hExtern, Buffer$
                            TCP_Print hIntern, Buffer$
                        END IF
                    '
                    CASE "LAST", "SLAVE", "DATE", "MODE", "NEWGROUPS"
                       TCP_Print hExtern, Buffer$
                       TCP_Line hExtern, Buffer$
                       TCP_Print hIntern, Buffer$
                    ' Befehle die mit "." abgeschlossen werden
                    CASE "ARTICLE", "HELP", "HEAD", "LIST", "BODY", "LISTGROUP", "XHDR", "XPAT"
                        TCP_Print hExtern, Buffer$
                        TCP_Line hExtern, Buffer$
                        TCP_Print hIntern, Buffer$
                        IF LEFT$(Buffer$, 3) > "399" THEN
                        ELSE
                            TCP_Copy hExtern, hIntern
                        END IF
                    CASE "XOVER"
                         NntpReadGroup hIntern, hExtern, Newsgroup$, Buffer$
                    CASE ""
                    CASE ELSE
                        TCP_Print hIntern, "500 command not (yet) implemented"
                END SELECT
                SLEEP 10
            LOOP UNTIL Cmd$ = "QUIT" OR pr(hIntern).SocketError = %True OR pr(hExtern).SocketError = %True
        END IF

        ' externe Verbindung beenden
        IF pr(hExtern).SocketError  = %True THEN
            LogWrite "Nntp-Connection lost ...", hExtern, %LogState_OtherError
        ELSE
            TCP_Print hExtern, "QUIT"
        END IF
        TCP_Close hExtern
        TCP_FreeHandle hExtern

        ' interne Verbindung beeenden
        IF pr(hIntern).SocketError  = %True THEN
            LogWrite "Nntp-Connection lost ...", hIntern, %LogState_OtherError
        ELSE
            TCP_Print hIntern, "205 NNTP-SpamProxy " + Version$ + " Server #" + _
                          TRIM$(STR$(hIntern))+ ", good bye spam"
        END IF
        TCP_Close hIntern
        TCP_FreeHandle hIntern

        THREAD CLOSE pr(hIntern).hThread TO Result&

END FUNCTION

FUNCTION NntpIncomingLogin(BYVAL hIntern AS LONG, hExtern AS LONG, NntpServer AS STRING, _
                           NntpUser AS STRING, NntpPass AS STRING) AS LONG

        LOCAL Buffer       AS STRING      '
        LOCAL Response     AS STRING
        LOCAL Cmd          AS STRING      '
        LOCAL Authrunning  AS LONG        '
        LOCAL Passrunning  AS LONG        '
        LOCAL NntpLogin    AS LONG        '
        LOCAL p            AS LONG        '
        LOCAL Arg          AS STRING

        PassRunning    = %False
        NntpLogin      = 255              ' -1 = Incoming Fehler
                                          '  0 = intern & extern erfolgreich
                                          '  1 = Externer Fehler
        DO
            TCP_Line hIntern, Buffer$
            'IF pr(hIntern).SocketTimeout = %True OR pr(hExtern).SocketTimeout = %True THEN
            '    STDOUT "Socket #" + TRIM$(STR$(hIntern))+ " closed by remote host!"
            '    STDOUT "Any key ..."
            '    WAITKEY$
            'END IF

            Cmd$ = UCASE$(PARSE$(Buffer$, " ", 1) + " " + PARSE$(Buffer$, " ", 2))
            Arg$ = PARSE$(Buffer$, " ", 3)

            SELECT CASE Cmd$
                CASE "AUTHINFO USER"
                    Arg$ = TRIM$(Arg$)
                    NntpServer$ = PARSE$(Arg$, "#", 1)
                    NntpUser$   = PARSE$(Arg$, "#", 2)
                    PassRunning = %True
                    TCP_Print hIntern, "381 More authentication information required"
                CASE "AUTHINFO PASS"
                    IF PassRunning = %True THEN
                       NntpPass$     = PARSE$(Arg$, "#", 1)
                       hExtern = TCP_Open(NntpServer$, NntpPortOutgoing)
                       pr(hExtern).SocketTimeout = NntpTimeout    ' Nntp-Timeout eintragen
                       TCP_Line hExtern, Buffer$
                       IF hExtern > 0 THEN
                           Logwrite "Bridge from #" + TRIM$(STR$(hIntern)) + " to #" + _
                                    TRIM$(STR$(hExtern)), hIntern, %LogState_Normal
                           IF NntpAuthentication(hExtern, NntpUser, NntpPass, Response) = %True THEN
                               Logwrite "NNTP Connection established", hExtern, %LogState_RasDialResp
                               TCP_Print hIntern, "281 Authenticaion accepted from " + NntpServer$
                               NntpLogin = 0
                           ELSE
                               Logwrite "No permission", hExtern, %LogState_RasDialResp
                               TCP_Print hIntern, Response
                               NntpLogin = 1
                           END IF
                       ELSE
                           TCP_Print hIntern, "502 " + NntpServer$ + " not found/ready"
                           NntpLogin = 1
                       END IF
                    ELSE
                        TCP_Print hIntern,"381 more authentication information required"
                    END IF
                CASE "QUIT"
                    NntpLogin = -1
                CASE ELSE
                    TCP_Print hIntern,"480 Authentication required"
            END SELECT
        LOOP WHILE NntpLogin = 255 AND pr(hIntern).SocketError = %False AND pr(hExtern).SocketError = %False

        FUNCTION = NntpLogin

END FUNCTION

'-------------------------------------------------------------------------------------------
' Nntp, Connect to News Server
'-------------------------------------------------------------------------------------------
FUNCTION NntpAuthentication(BYVAL hNntp AS LONG, BYVAL NntpUser AS STRING, BYVAL NntpPass AS STRING, Response AS STRING) AS LONG

        LOCAL Buffer        AS STRING      ' Rcvd-Buffer
        LOCAL Result        AS LONG        '
        LOCAL Temp          AS STRING

        ON ERROR GOTO NntpAuthenticationError

        FUNCTION = %False                  '

        ' ist Authentifizierung ntig
        IF NntpUser = "" THEN
            ' keine weitere Authentifizierung notwendig
            FUNCTION = %True
        ELSE
            ' Login mit Username und Pawort
            Logwrite "Sending AUTHINFO USER", hNntp, %LogState_BriefMsg
            TCP_Send hNntp, "AUTHINFO USER " & NntpUser + Eol$
            TCP_Line hNntp, Buffer
            CpsRcvd = CpsRcvd + LEN(Buffer$) + 2

            ' kein weiteres Pawort bentigt
            IF LEFT$(Buffer, 3) = "281" THEN
                 FUNCTION = %True
            ' ... und Pawort senden
            ELSEIF LEFT$(Buffer, 3) = "381" THEN
                Logwrite "Sending AUTHINFO PASS", hNntp, %LogState_BriefMsg
                TCP_Send hNntp, "AUTHINFO PASS " & NntpPass + Eol$
                TCP_Line hNntp, Buffer
                CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                IF LEFT$(Buffer, 3) = "281" THEN
                    FUNCTION = %True
                ELSE
                    Response = Buffer
                    Logwrite Buffer$, hNntp, %LogState_OtherError
                END IF
            ' TimeOut vom Server
            ELSEIF LEFT$(Buffer, 3) = "503" THEN
                Response = Buffer
                Logwrite Buffer$, hNntp, %LogState_OtherError
'                CloseSocket hNntpGlobal(Thread_Id)
            ELSE
                Response = Buffer
                Logwrite Buffer$, hNntp, %LogState_OtherError
            END IF
        END IF
        EXIT FUNCTION

NntpAuthenticationError:
        FUNCTION = %False
END FUNCTION


'-------------------------------------------------------------------------------------------
' Nntp, Newgroup lesen
'-------------------------------------------------------------------------------------------
FUNCTION NntpReadGroup(BYVAL hIntern AS LONG, BYVAL hExtern AS LONG, BYVAL Newsgroup AS STRING, BYVAL Cmd AS STRING) AS LONG

        LOCAL ArticleState AS LONG        ' Status des Artikels (Filter, Header, komplett, etc.)
        LOCAL Number       AS LONG        ' XOVER: Artikelnummer
        LOCAL Betreff      AS STRING      ' XOVER: Betreff
        LOCAL MailFrom     AS STRING      ' XOVER: Absender
        LOCAL MsgDate      AS STRING      ' XOVER: Datum
        LOCAL MsgId        AS STRING      ' XOVER: Message_Id
        LOCAL MsgBezug     AS STRING      ' XOVER: References
        LOCAL MsgLen       AS LONG        ' XOVER: Lnge des Artikels
        LOCAL MsgLines     AS STRING      ' XOVER: Lines
        LOCAL MsgXRef      AS STRING      ' XOVER: XRef
        LOCAL CSZiel       AS STRING      ' Ergebnis des Artikelfilters (CrossSecretary)
        LOCAL CSZeile      AS STRING      ' Ergebnis des Artikelfilters (CrossSecretary)
        LOCAL CSReturn     AS LONG        ' Ergebnis des Artikelfilters (%True=etwas gefunden)
        LOCAL Buffer       AS STRING
        LOCAL Result       AS LONG

        ON ERROR GOTO NntpNextReadGroupError

        Buffer$ = Cmd$

        ' XOVER senden
        TCP_Print hExtern, Buffer$
        TCP_Line hExtern, Buffer
        TCP_Print hIntern, Buffer$
        CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
        IF LEFT$(Buffer, 3) = "224" THEN
            ' Header lesen und gegebenfalls filtern
            DO
                TCP_Line hExtern, Buffer
                CpsRcvd = CpsRcvd + LEN(Buffer$) + 2
                IF Buffer$ = "" THEN
                     Logwrite "Connection lost during XOVER", hIntern, %LogState_OtherError
                     ' CloseSocket hNntpGlobal(Thread_Id)
                ELSEIF Buffer$ <> "." THEN
                    ArticleState = 0
                    Number    = VAL(PARSE$(Buffer$, CHR$(9), 1))
                    Betreff   = PARSE$(Buffer$, CHR$(9), 2)
                    MailFrom  = PARSE$(Buffer$, CHR$(9), 3)
                    MsgDate   = PARSE$(Buffer$, CHR$(9), 4)
                    MsgId     = PARSE$(Buffer$, CHR$(9), 5)
                    MsgBezug  = PARSE$(Buffer$, CHR$(9), 6)
                    MsgLen    = VAL(PARSE$(Buffer$, CHR$(9), 7))
                    MsgLines  = PARSE$(Buffer$, CHR$(9), 8)
                    MsgXRef   = PARSE$(Buffer$, CHR$(9), 9)

                    IF CS = %True THEN
                        CSReturn = NntpFilterArticle(Newsgroup, _
                                                    Get_Qp2Text$(Get_XP_Adress(MailFrom)), _
                                                    Get_Qp2Text$(Betreff), MsgID$, MsgBezug$, _
                                                    CSZiel$, CSZeile$)
                        SELECT CASE CSReturn
                            CASE 0: ' Normal (XP-Limits beachten)
                                    ArticleState = 0
                            CASE 1: ' (RETR) Artikel trotz eventuellem NntpMaxLen holen
                                    ArticleState = 0
                            CASE 2: ' (SKIP) Artikel berspringen/filtern
                                    ArticleState = 1
                            CASE 3: ' (HEAD) nur Artikel-Header holen
                                    ArticleState = 3
                        END SELECT
                    END IF
                    SELECT CASE ArticleState
                        CASE 0: ' XOVER-Segment normal an den Client schicken
                                TCP_Print hIntern, Buffer$
                        CASE 1:
                                Logwrite "Filter: " + MsgId + CrLf$ + CHR$(9, 9, 9) + _
                                         " from: " + Get_NC_Adress(MailFrom$) + CrLf$ + CHR$(9, 9, 9) + _
                                         " Subject: " + Get_Qp2Text$(Betreff$) + CrLf$ + CHR$(9, 9, 9) + _
                                         " Reason: " + CSZeile$, hExtern, %LogState_Filter
                    END SELECT
                ELSE
                    TCP_Print hIntern, Buffer$
                END IF
            LOOP UNTIL Buffer$ = "."
        END IF
        EXIT FUNCTION

NntpNextReadGroupError:
        FUNCTION = %False
END FUNCTION


'-------------------------------------------------------------------------------------------
' Nntp, Article filtern
'-------------------------------------------------------------------------------------------

FUNCTION NntpFilterArticle(BYVAL Newsgroup AS STRING, BYVAL MailFrom AS STRING, BYVAL Betreff AS STRING, BYVAL MsgID AS STRING, BYVAL MsgBezug AS STRING, CSZiel AS STRING, CSZeile AS STRING) AS LONG

        LOCAL CS           AS CS_Data     ' CrossSecretary: Strukturen
        LOCAL CSBrett      AS STRING      ' Newsgroup in ZC/CS Style gewandelt
        LOCAL CSNewsgroup  AS STRING      ' beinhaltet das letzte gefundene Ziel-Brett
        LOCAL CSHeader()   AS STRING      ' Header der Mail
        LOCAL LastBrett    AS STRING

        DIM Kriterien(10)  AS STRING      '
        REDIM CSHeader(10)                ' Array lschen

        ON ERROR GOTO NntpFilterMessageError

        FUNCTION = 0                      ' 1=Download, 2=Skip, 3=Head, 10=Kill, 20=New Envelope

        CS.BrettPos&   = 1                ' Defaultwerte damit CS an der ersten Zeile
        CS.KritPos&    = 0                ' zu filtern beginnt. Die letzte gefundene
        CS.ReturnFlag& = 0                ' Zeile ist der endgltige Wert
        CSNewsgroup$   = ""               '

        ' Newsgroup-Namen nach CS Style konvertieren
        CSBrett$ = "/" + Newsgroup$
        REPLACE "." WITH "/" IN CSBrett$

        DO
             CALL CS_Filter (CSBrett$, MailFrom$, Betreff$, MsgBezug$, CSZeile$, MsgId$, CSHeader(), _
                             Kriterien$(), CSZiel$, LastBrett$, FilterCfg$(), VARPTR(CS))
            IF CS.ReturnFlag = 1 THEN
                'PRINT "Mailfrom     :"; Mailfrom$
                'PRINT "Betreff      :"; Betreff$
                'PRINT "Zeile$       :"; Zeile$
                'PRINT "Ergebnis     :"; ">>" + CSZiel$ + "<<"
                CSZiel$ = TRIM$(CSZiel$)
                SELECT CASE CSZiel$
                    CASE "RETR"
                        FUNCTION = 1      ' Artikel immer holen (ignoriert NntpMaxLen!)
                    CASE "SKIP"
                        FUNCTION = 2      ' Artikel berspringen
                    CASE "HEAD"
                        FUNCTION = 0  ' bei OpenXP ignorieren
                    CASE "DELE"
                        FUNCTION = 0      ' ignorieren fr Zusammenarbeit mit Mail-Sourcen
                    CASE ELSE
                        FUNCTION = 20     ' Artikel wird in andere Newsgroup umgeleitet
                        CSNewsgroup$ = CSZiel$
                END SELECT                '
                'WAITKEY$
            ELSE
            END IF
        LOOP WHILE CS.ReturnFlag& = 1 AND (CS.Optionen& AND 16384) = 0
        CSZiel$ = CSNewsgroup$            ' neue Envelope zurckgeben, da CSFilter beim letzten
        EXIT FUNCTION                     ' Durchlauf CSZiel$ lscht

NntpFilterMessageError:
        FUNCTION = 0
END FUNCTION




FUNCTION Pop3IncomingLogin(BYVAL hIntern AS LONG, hExtern AS LONG, Pop3Server AS STRING, _
                           Pop3User AS STRING, Pop3Pass AS STRING, Messages AS LONG, _
                           MsgSize AS LONG , MailAktiv() AS LONG, MailDeleted() AS LONG, _
                           MailMsgId() AS STRING, MailUidl() AS STRING, MailLaenge() AS LONG) AS LONG

        LOCAL Buffer       AS STRING      '
        LOCAL Cmd          AS STRING      '
        LOCAL Authrunning  AS LONG        '
        LOCAL Passrunning  AS LONG        '
        LOCAL Pop3Login    AS LONG        '
        LOCAL Pop3Auth     AS STRING      '
        LOCAL Pop3Envelope AS STRING      '
        LOCAL p            AS LONG        '
        LOCAL i            AS LONG        '
        LOCAL Arg          AS STRING

        PassRunning    = %False
        Pop3Login      = 255              ' -1 = Incoming Fehler
                                          '  0 = intern & extern erfolgreich
                                          '  1 = Externer Fehler
        DO
            TCP_Line hIntern, Buffer$

            Cmd$ = UCASE$(PARSE$(Buffer$, " ", 1))
            Arg$ = PARSE$(Buffer$, " ", 2)

            SELECT CASE Cmd$
                CASE "USER"
                    Arg$ = TRIM$(Arg$)
                    i = INSTR(Arg$, ":")
                    IF i > 0 THEN
                        Pop3Auth = PARSE$(Arg$, ":", 1)
                        Arg$     = MID$(Arg$, i + 1)
                    END IF
                    Pop3Server$ = PARSE$(Arg$, "#", 1)
                    Pop3User$   = PARSE$(Arg$, "#", 2)
                    PassRunning = %True
                    TCP_Print hIntern, "+OK More authentication information required"
                CASE "PASS"
                    IF PassRunning = %True THEN
                       Pop3Pass$     = PARSE$(Arg$, "#", 1)
                       Pop3Envelope$ = PARSE$(Arg$, "#", 2)
                       IF Pop3Envelope$ = "" THEN
                           Pop3Envelope$ = "user@localhost"
                       END IF
                       hExtern = TCP_Open(Pop3Server$, Pop3PortOutgoing)
                       pr(hExtern).SocketTimeout = Pop3Timeout    ' Pop3-Timeout eintragen
                       Pop3KillMsg(hExtern)      = ""             ' Pop3 KillReport lschen
                       TCP_Line hExtern, Buffer$
                       IF hExtern > 0 THEN
                           Logwrite "Bridge from #" + TRIM$(STR$(hIntern)) + " to #" + _
                                    TRIM$(STR$(hExtern)), hIntern, %LogState_Normal

                           IF Pop3Authentication(hExtern, Pop3User, Pop3Pass, Pop3Auth, %False, "") = %True THEN
                               IF Pop3GetMailBox(hExtern, Pop3Server, Pop3User, Messages, MsgSize, MailAktiv(), MailDeleted(), MailMsgId(), MailUidl(), Maillaenge(), Pop3Envelope) = %True THEN
                                   TCP_Print hIntern, "+OK Mailbox scan running to " + Pop3Server$ + " successfull"
                                   Pop3Login = 0
                               ELSE
                                   TCP_Print hIntern, "+ERR external Mailbox scan"
                                   Pop3Login = 1
                               END IF
                           ELSE
                               TCP_Print hIntern, "+ERR " + Pop3Server$ + " authentication error"
                               Pop3Login = 1
                           END IF
                       ELSE
                           TCP_Print hIntern, "+ERR " + Pop3Server$ + " not found/ready"
                           Pop3Login = 1
                       END IF
                    ELSE
                        TCP_Print hIntern,"-ERR Authentication rejected"
                    END IF
                CASE "QUIT"
                    Pop3Login = -1
                CASE ELSE
                    TCP_Print hIntern,"-ERR Authentication required"
            END SELECT
        LOOP WHILE Pop3Login = 255 AND pr(hIntern).SocketError = %False AND pr(hExtern).SocketError = %False

        FUNCTION = Pop3Login

END FUNCTION


FUNCTION Pop3Incoming(BYVAL hIntern AS LONG) AS LONG

        LOCAL Buffer       AS STRING      '

        LOCAL Cmd          AS STRING      '
        LOCAL Pop3Server   AS STRING
        LOCAL Pop3User     AS STRING      '
        LOCAL Pop3Pass     AS STRING      '
        LOCAL hExtern      AS LONG        ' Outgoing Socket-Handle

        LOCAL Messages     AS LONG        '
        LOCAL MsgSize      AS LONG        '
        LOCAL MsgCount     AS LONG        ' Anzahl aller nach dem Filtern verbliebener Messages
        LOCAL MsgNew       AS LONG        '
        LOCAL MsgSizeNew   AS LONG        '
        LOCAL MailAktiv()  AS LONG        ' Aktiv-Status der Mail
        LOCAL MailDeleted()AS LONG        ' Mail in der Zwischenzeit gelscht
        LOCAL MailMsgId()  AS STRING      ' MessageID
        LOCAL MailUidl()   AS STRING      ' Uidl
        LOCAL MailLaenge() AS LONG        ' Lnger der Mail
        LOCAL MailFilter   AS LONG        ' Ergebnis des Mailfilters / Nummer der Filterreportmail

        REDIM MailAktiv(%Threads)         '
        REDIM MailDeleted(%Threads)       '
        REDIM MailMsgId(%Threads)         '
        REDIM MailUidl(%Threads)          '
        REDIM MailLaenge(%Threads)        '

        LOCAL Crc          AS LONG        '
        LOCAL i            AS LONG        '
        LOCAL Arg          AS STRING
        LOCAL Msg          AS LONG
        LOCAL Result       AS LONG

        LOCAL MailData     AS Mail_Data

        TCP_Print hIntern, "+OK POP3-SpamProxy " + Version$ + " Server #" + _
                          TRIM$(STR$(hIntern))+ " ready, (c) by Thomas Gohel"

        Pop3User$ = ""
        Pop3Pass$ = ""
        pr(hIntern).user = Pop3User$

        ' Incoming Login auswerten und Verbindung zum eigentlichen Pop3-Server aufbauen
        Result& = Pop3IncomingLogin(hIntern, hExtern, Pop3Server$, Pop3User$, Pop3Pass$, _
                                    Messages&, MsgSize&, MailAktiv&(), MailDeleted&(), _
                                    MailMsgId$(), MailUidl$(), Maillaenge&())

        ' Weiterreichen an den Client
        IF Result& = 0 THEN
            ' Anzahl der ungefilterten Messages ermitteln
            MsgNew     = 0
            MsgCount   = 0
            MsgSizeNew = 0
            MailFilter = 0
            FOR i& = 1 TO Messages
                ' Anzahl der verbliebenen Messages ermitteln
                IF MailAktiv(i&) = %True THEN
                    MsgSizeNew = MsgSizeNew + MailLaenge(i&)
                    INCR MsgNew
                    INCR MsgCount
                END IF
                ' wenn Mails gelscht wurden, dann mu Report-Mail erstellt werden
                IF MailDeleted(i&) = %True THEN
                    MailFilter = 1
                END IF
            NEXT i&
            ' Report-Mail hinten anhngen
            IF MailFilter = 1 THEN
                Pop3KillLog hExtern   ' Reportmail erstellen
                INCR MsgNew
                INCR MsgCount
                INCR Messages
                Crc = Crc32(STRPTR(Pop3KillMsg(hExtern)), LEN(Pop3KillMsg(hExtern)), -1)
                Crc = Crc XOR -1&
                MailAktiv(Messages)   = %True
                MailDeleted(Messages) = %False
                MailLaenge(Messages)  = LEN(Pop3KillMsg(hExtern))
                MailUidl(Messages)    = HEX$(Crc) + ".spamproxy"
                MsgSizeNew            = MsgSizeNew + MailLaenge(Messages)
            END IF

            Logwrite TRIM$(STR$(MsgCount)) + " Messages" + " with" + STR$(MsgSizeNew) + " (Bytes)", hIntern, %LogState_TransStat
            ' eigentliche Abfrage-Schleife

            DO
                TCP_Line hIntern, Buffer$

                IF pr(hIntern).SocketError = %True THEN
                    LogWrite "Socket #" + TRIM$(STR$(hIntern))+ " closed by remote host!", hIntern, %LogState_Normal
                END IF
                IF pr(hExtern).SocketError = %True THEN
                    LogWrite "Socket #" + TRIM$(STR$(hExtern))+ " closed by remote host!", hExtern, %LogState_Normal
                END IF

                Cmd$ = UCASE$(PARSE$(Buffer$, " ", 1))
                Arg$ = PARSE$(Buffer$, " ", 2)

                SELECT CASE Cmd$
                    CASE "QUIT"
                        TCP_Print hExtern,"QUIT"
                        TCP_Line hExtern, Buffer$
                    CASE "RSET"
                        TCP_Print hIntern,"+OK " + Pop3User$ + " has" + STR$(Messages) + " messages ("+TRIM$(STR$(MsgSizeNew)) + " octets)"
                    CASE "NOOP"
                        TCP_Print hIntern,"+OK"
                    CASE "DELE"
                        Pop3TransferDele Arg$, hIntern, hExtern, Messages&, MsgCount&, MsgNew&, MsgSizeNew&, MailAktiv(), MailDeleted&(), MailLaenge&(), Mailfilter&
                    CASE "RETR"
                        Pop3TransferRetr Arg$, hIntern, hExtern, Messages&, MsgCount&, MailAktiv&(), MailDeleted&(), MailLaenge&(), Mailfilter&
                    CASE "LIST"
                        Pop3PutList Arg$, hIntern, Messages&, MsgCount&, MsgNew&, MailAktiv&(), MailDeleted&(), MailLaenge&()
                    CASE "STAT"
                        TCP_Print hIntern,"+OK" + STR$(MsgNew) + STR$(MsgSizeNew)
                    CASE "STATALL"
                        TCP_Print hIntern,"+OK" + STR$(Messages) + STR$(MsgSize)
                    CASE "TOP"
                        Pop3TransferTop Arg$, hIntern, hExtern, Messages&, MsgCount&, MailAktiv&(), MailDeleted&(), MailLaenge&(), Mailfilter&
                    CASE "UIDL"
                        Pop3PutUidl Arg$, hIntern, Messages&, MsgCount&, MsgNew&, MailAktiv&(), MailDeleted&(), MailUidl$()
                    CASE "HELP"
                        Pop3PutHelp hIntern
                    CASE ELSE
                        TCP_Print hIntern,  MsgCmdUnknown
                END SELECT
                SLEEP 10
            LOOP UNTIL Cmd$ = "QUIT" OR pr(hIntern).SocketError = %True OR pr(hExtern).SocketError = %True
        END IF

        ' externe Verbindung beenden
        IF pr(hExtern).SocketError = %True THEN
            Logwrite "Connection lost ...", hExtern, %LogState_OtherError
        ELSE
            TCP_Print hExtern, "QUIT"
        END IF
        TCP_Close hExtern
        TCP_FreeHandle hExtern

        ' interne Verbindung beenden
        IF pr(hIntern).SocketError = %True THEN
            Logwrite "Connection lost ...", hIntern, %LogState_OtherError
        ELSE
            TCP_Print hIntern, "+OK POP3-SpamProxy " + Version$ + " Server #" + _
                          TRIM$(STR$(hIntern))+ ", good bye spam"
        END IF
        TCP_Close hIntern
        TCP_FreeHandle hIntern

        THREAD CLOSE pr(hIntern).hThread TO Result&

END FUNCTION

'-------------------------------------------------------------------------------------------
' Relay Blacklist ffnen
'-------------------------------------------------------------------------------------------
FUNCTION RBL_Open() AS LONG

        LOCAL hRbl        AS LONG        ' Handle fr Dupebase
        LOCAL TEXT        AS STRING      ' Zeile
        LOCAL LineCount   AS LONG        '
        LOCAL eoFile      AS LONG        '

        LOCAL IP          AS DWORD       '
        LOCAL IP_AddOff   AS DWORD
        LOCAL IP_Block    AS STRING
        LOCAL CIDR        AS LONG
        LOCAL IP_Start    AS BYTE PTR
        LOCAL IP_End      AS BYTE PTR

        IP_Start = VARPTR(IP)
        IP_End   = VARPTR(IP_AddOff)

        ON ERROR RESUME NEXT

        Pop3BlacklistMax& = 0

        LineCount = 0
        eoFile    = %True

        IF FileOpen(hRbl, AppPath + "SPAMPRXY.RBL", -1) = %True THEN
            IF LOF(hRbl) = 0 THEN
                PUT$ #hRbl, "# SpamProxy RelayBlacklist      #" + CHR$(13,10)
                PUT$ #hRbl, "# Form: IP/CIDR <Space> Comment #" + CHR$(13,10)
                CLOSE #hRbl
            ELSE
                DIM Pop3BlackIps1(5000)
                DIM Pop3BlackIps2(5000)
                DIM Pop3Blacklist(5000)
                Logwrite "Loading Relay Blacklist", -1, %LogState_BriefMsg
                DO
                    Text$ = SmtpNextLine$(hRbl, LineCount&, eoFile&)
                    IF LEFT$(Text$, 1) = "#" THEN
                    ELSE
                        ' IP-Bereich ermitteln und CDIR
                        IP_Block$ = PARSE$(Text$, " ", 1)
                        CIDR&     = VAL(PARSE$(IP_Block$, "/", 2))
                        IP_Block$ = PARSE$(IP_Block$, "/", 1)
                        IF CIDR& = 0 THEN
                            CIDR& = 32
                        END IF

                        ' IP auf LONG umrechnen (Wichtig: Intel-Notation!)
                        @IP_Start[00] = VAL(PARSE$(IP_Block$, ".", 4))
                        @IP_Start[01] = VAL(PARSE$(IP_Block$, ".", 3))
                        @IP_Start[02] = VAL(PARSE$(IP_Block$, ".", 2))
                        @IP_Start[03] = VAL(PARSE$(IP_Block$, ".", 1))

                        IP_AddOff = IP + (2^(32-CIDR&)) - 1
                        '? CIDR&, "IP1: " + FORMAT$(@IP_Start[3]) & "." & FORMAT$(@IP_Start[2]) & "." & FORMAT$(@IP_Start[1]) & "." & FORMAT$(@IP_Start[0]);
                        '? " - " + FORMAT$(@IP_End[3]) & "." & FORMAT$(@IP_End[2]) & "." & FORMAT$(@IP_End[1]) & "." & FORMAT$(@IP_End[0])
                        INCR Pop3BlacklistMax&
                        IF Pop3BlacklistMax& = UBOUND(Pop3Blacklist) THEN
                            REDIM PRESERVE Pop3Blacklist(UBOUND(Pop3Blacklist) + 2000)
                            REDIM PRESERVE Pop3BlackIPs1(UBOUND(Pop3BlackIPs1) + 2000)
                            REDIM PRESERVE Pop3BlackIPs2(UBOUND(Pop3BlackIPs2) + 2000)
                        END IF
                        Pop3Blacklist(Pop3BlacklistMax&) = Text$
                        Pop3BlackIPs1(Pop3BlacklistMax&) = IP
                        Pop3BlackIPs2(Pop3BlacklistMax&) = IP_AddOff
'? Text$
'? FORMAT$(IP, "###,###,###"), FORMAT$(Pop3BlackIPs(Pop3BlacklistMax&, 1), "###,###,###"), FORMAT$(Pop3BlackIPs(Pop3BlacklistMax&, 2), "###,###,###")
'WAITKEY$
                    END IF
                LOOP UNTIL Text$ = ""
                CLOSE #hRbl
            END IF
        ELSE
        END IF

END FUNCTION

'-------------------------------------------------------------------------------------------
' Relay Blacklist, Received-Zeile nach IPs scannen
'-------------------------------------------------------------------------------------------
FUNCTION RBL_ScanReceived(BYVAL Buffer AS STRING, Reason AS STRING) AS LONG

        LOCAL IP_Address  AS STRING
        LOCAL IP_Mask     AS STRING      '
        LOCAL IP          AS DWORD       '
        LOCAL p           AS BYTE PTR    '
        LOCAL RegStart    AS LONG
        LOCAL RegPos      AS LONG
        LOCAL RegLen      AS LONG

        FUNCTION = %False

        p = VARPTR(IP)

        ' RegEx-Ausdruck zur Suche der IPs
        IP_Mask$ = "\[[0-9]+_[0-9]+_[0-9]+_[0-9]+\]"

        ' Received-Zeile vereinfachen
        REPLACE "." WITH "_" IN Buffer$
        REPLACE "(" WITH "[" IN Buffer$
        REPLACE ")" WITH "]" IN Buffer$

        ' und nun die IPs in den Receveid-Zeilen suchen
        RegStart& = 0
        DO
            REGEXPR IP_Mask$ IN Buffer$ AT RegStart& TO RegPos&, RegLen&
            IF RegPos& > 0 THEN
                Ip_Address$ = MID$(Buffer$, RegPos& + 1 , RegLen& - 2)
                '? "Rec_Ip: " + ">" + IP_Address$ + "<"

                @p[00] = VAL(PARSE$(IP_Address$, "_", 4))
                @p[01] = VAL(PARSE$(IP_Address$, "_", 3))
                @p[02] = VAL(PARSE$(IP_Address$, "_", 2))
                @p[03] = VAL(PARSE$(IP_Address$, "_", 1))

                IF RBL_Check(IP, Reason) = %True THEN
                    FUNCTION = %True
                    EXIT LOOP
                END IF
                RegStart& = RegPos& + RegLen&
            END IF
        LOOP UNTIL RegPos& = 0

END FUNCTION

'-------------------------------------------------------------------------------------------
' Relay Blacklist, IP aus Received-Zeile mit Blacklist vergleichen
'-------------------------------------------------------------------------------------------
FUNCTION RBL_Check(BYVAL IP AS DWORD, Reason AS STRING) AS LONG

        LOCAL IP_Mask     AS STRING      '
        LOCAL i           AS LONG        '

        LOCAL p           AS BYTE PTR    '
        p = VARPTR(IP)

        FUNCTION = %False
        i& = 0
        FOR i& = 1 TO Pop3BlacklistMax&
            IF IP >= Pop3BlackIPs1(i&) AND IP <= Pop3BlackIPs2(i&) THEN
                Reason = Pop3Blacklist(i&)
                FUNCTION = %True
                EXIT FOR
            END IF
        NEXT i&
END FUNCTION


'-------------------------------------------------------------------------------------------
' IP-Accesslist ffnen
'-------------------------------------------------------------------------------------------
FUNCTION IP_Open() AS LONG

        LOCAL hIPAccess   AS LONG        ' Handle fr Dupebase
        LOCAL TEXT        AS STRING      ' Zeile
        LOCAL LineCount   AS LONG        '
        LOCAL eoFile      AS LONG        '

        LOCAL IP          AS DWORD       '
        LOCAL IP_AddOff   AS DWORD
        LOCAL IP_Block    AS STRING
        LOCAL CIDR        AS LONG
        LOCAL IP_Start    AS BYTE PTR
        LOCAL IP_End      AS BYTE PTR

        IP_Start = VARPTR(IP)
        IP_End   = VARPTR(IP_AddOff)

        ON ERROR RESUME NEXT

        IPAccessMax& = 0

        LineCount = 0
        eoFile    = %True

        IF FileOpen(hIPAccess, AppPath + "ACCESS.IP", -1) = %True THEN
            IF LOF(hIPAccess) = 0 THEN
                PUT$ #hIPAccess, "# SpamProxy IP access list      #" + CHR$(13,10)
                PUT$ #hIPAccess, "# Form: IP/CIDR <Space> Comment #" + CHR$(13,10)
                CLOSE #hIPAccess
            ELSE
                DIM IPAccess1(100)
                DIM IPAccess2(100)
                Logwrite "Loading IP access list", -1, %LogState_BriefMsg
                DO
                    Text$ = SmtpNextLine$(hIPAccess, LineCount&, eoFile&)
                    IF LEFT$(Text$, 1) = "#" THEN
                    ELSE
                        ' IP-Bereich ermitteln und CDIR
                        IP_Block$ = PARSE$(Text$, " ", 1)
                        CIDR&     = VAL(PARSE$(IP_Block$, "/", 2))
                        IP_Block$ = PARSE$(IP_Block$, "/", 1)
                        IF CIDR& = 0 THEN
                            CIDR& = 32
                        END IF

                        ' IP auf LONG umrechnen (Wichtig: Intel-Notation!)
                        @IP_Start[00] = VAL(PARSE$(IP_Block$, ".", 4))
                        @IP_Start[01] = VAL(PARSE$(IP_Block$, ".", 3))
                        @IP_Start[02] = VAL(PARSE$(IP_Block$, ".", 2))
                        @IP_Start[03] = VAL(PARSE$(IP_Block$, ".", 1))

                        IP_AddOff = IP + (2^(32-CIDR&)) - 1
                        '? CIDR&, "IP1: " + FORMAT$(@IP_Start[3]) & "." & FORMAT$(@IP_Start[2]) & "." & FORMAT$(@IP_Start[1]) & "." & FORMAT$(@IP_Start[0]);
                        '? " - " + FORMAT$(@IP_End[3]) & "." & FORMAT$(@IP_End[2]) & "." & FORMAT$(@IP_End[1]) & "." & FORMAT$(@IP_End[0])
                        INCR IPAccessMax&
                        IF IPAccessMax& = UBOUND(IPAccess1) THEN
                            REDIM PRESERVE IPAccess1(UBOUND(IPAccess1) + 100)
                            REDIM PRESERVE IPAccess2(UBOUND(IPAccess2) + 100)
                        END IF
                        IPAccess1(IPAccessMax&) = IP
                        IPAccess2(IPAccessMax&) = IP_AddOff
'? Text$
'? FORMAT$(IP, "###,###,###"), FORMAT$(Pop3BlackIPs(Pop3BlacklistMax&, 1), "###,###,###"), FORMAT$(Pop3BlackIPs(Pop3BlacklistMax&, 2), "###,###,###")
'WAITKEY$
                    END IF
                LOOP UNTIL Text$ = ""
                CLOSE #hIPAccess
            END IF
        ELSE
        END IF

END FUNCTION


'-------------------------------------------------------------------------------------------
' Access-List
'-------------------------------------------------------------------------------------------
FUNCTION IP_Access(BYVAL UnixIP AS LONG) AS LONG

        LOCAL IntelIP  AS QUAD            ' QUAD zum rechnen
        LOCAL bU       AS BYTE PTR        ' Temp fr Unix-IP
        LOCAL bI       AS BYTE PTR        ' Temp fr Intel-IP

        bU = VARPTR(UnixIP)
        bI = VARPTR(IntelIP)

        @bI[00] = @bU[03]                 ' Unix-IP zum Vergleich auf Intel-IP umrechnen,
        @bI[01] = @bU[02]                 ' damit der IP-Check deutlich komfortabel und
        @bI[02] = @bU[01]                 ' einfacher wird
        @bI[03] = @bU[00]

        '? ">"; FORMAT$(@bI[0]) & "." & FORMAT$(@bI[1]) & "." & FORMAT$(@bI[2]) & "." & FORMAT$(@bI[3])
        '? ">"; FORMAT$(@bU[0]) & "." & FORMAT$(@bU[1]) & "." & FORMAT$(@bU[2]) & "." & FORMAT$(@bU[3])
        '? STR$(UnixIP), STR$(IntelIP)

        ' Abfragen ob IP in der Accessliste vorhanden ist
        FUNCTION = IP_Check(IntelIP)

END FUNCTION

'-------------------------------------------------------------------------------------------
' Relay Blacklist, IP aus Received-Zeile mit Blacklist vergleichen
'-------------------------------------------------------------------------------------------
FUNCTION IP_Check(BYVAL IP AS QUAD) AS LONG

        LOCAL IP_Mask     AS STRING      '
        LOCAL i           AS LONG        '

        LOCAL p           AS BYTE PTR    '
        p = VARPTR(IP)

        FUNCTION = %False
        i& = 0
        FOR i& = 1 TO IPAccessMax&
            IF IP >= IPAccess1(i&) AND IP <= IPAccess2(i&) THEN
                FUNCTION = %True
                EXIT FOR
            END IF
        NEXT i&

END FUNCTION

'-------------------------------------------------------------------------------------------
' einen freien Datensatz suchen
'-------------------------------------------------------------------------------------------
FUNCTION TCP_Freefile() AS LONG

        LOCAL i            AS LONG        '

        WaitForSingleObject Mutex_Accept,%INFINITE
        i& = 0
        ' freies Socket-Handle suchen fr Thread
        DO
           INCR i&
        LOOP WHILE pr(i&).hThread <> 0 AND i& < %Threads
        pr(i&).hThread = -1
        Releasemutex Mutex_Accept

        FUNCTION = i&

END FUNCTION

'-------------------------------------------------------------------------------------------
' reservierten Datensatz wieder freigeben
'-------------------------------------------------------------------------------------------
FUNCTION TCP_Freehandle(BYVAL i AS LONG) AS LONG

        WaitForSingleObject Mutex_Accept,%INFINITE

        pr(i&).hThread       = 0
        pr(i&).SocketTimeout = 0
        pr(i&).hSocket       = 0
        pr(i&).User          = ""
        pr(i&).Portnummer    = 0
        pr(i&).IP            = 0
        pr(i&).SocketError   = %False

        Releasemutex Mutex_Accept

        FUNCTION = i&

END FUNCTION


FUNCTION TCP_Open (BYVAL ServerName AS STRING, BYVAL ServerPort AS LONG) AS DWORD

        LOCAL s            AS DWORD       '
        LOCAL WSockData    AS WSAData
        LOCAL pHostEnt     AS hostentStru PTR
        LOCAL In_address   AS In_addr
        LOCAL sservent     AS servent PTR '
        LOCAL sockAddress  AS SOCKADDR_IN
        LOCAL dip_addr     AS ASCIIZ PTR
        LOCAL Hostname     AS ASCIIZ*64
        LOCAL HostTemp     AS STRING
        LOCAL Ip_Adr       AS DWORD
        LOCAL Cmd          AS LONG
        LOCAL Argp         AS LONG
        LOCAL n            AS LONG
        LOCAL i            AS LONG

        Hostname$ = Servername$

        ' freien internen Datensatz suchen und reservieren
        i& = TCP_Freefile

        FUNCTION = %Invalid_Socket                ' %Invalid_Socket = -1

        IF WSAStartup(%wsock_version, WSockData) THEN
            LogWrite "Winsocket Error!", i&, %LogState_FatalError
            WSACleanup
        ELSE
            'STDOUT wsaData.szDescription          ' Winsock-ID (Version, Date, Build)
            'STDOUT wsaData.szSystemStatus         ' Windows Version

            Ip_adr??? = Inet_Addr(Hostname$)

            IF Ip_adr??? = %INADDR_NONE THEN
                pHostEnt = GetHostByName(Hostname$)
                IF ISFALSE pHostEnt THEN
                    LogWrite "'" +  Hostname$ + "' not found!", i&, %LogState_FatalError
                    WSACleanup
                    EXIT FUNCTION
                ELSE
                    in_address.s_addr = @pHostEnt.@@h_list
                    dip_addr          = inet_ntoa(in_address.s_addr)
                    HostTemp          = @pHostEnt.@h_name + " (" + @dip_addr + ")"
                END IF
            ELSE
                in_address.s_addr=IP_adr???
            END IF

            s = Socket(%PF_INET, %SOCK_STREAM, %IPPROTO_TCP)
            IF s = %INVALID_SOCKET THEN
                LogWrite "Can't open a socket!", i&, %LogState_FatalError
                WSACleanup
            ELSE
                SockAddress.sin_family = %AF_INET
                SockAddress.sin_port   = htons(Serverport&)
                SockAddress.sin_addr   = in_address
                IF Cconnect(s, sockAddress, SIZEOF(sockAddress)) = 0 THEN
                    Logwrite "Outgoing connection to '" + HostTemp$ + "'  Port:" + STR$(ServerPort&), i&, %LogState_SessionInfo
                    ' Ergebnisse auswerten und in interne Datenstze eintragen
                    Cmd&  = %FIONBIO
                    Argp& = 1
                    n& = ioctlsocket( s, cmd&, argp& )
                    pr(i&).hThread       = 1  ' vorerst nur Default
                    pr(i&).hSocket       = s
                    pr(i&).ip            = in_address.s_addr
                    pr(i&).Portnummer    = Serverport&
                    pr(i&).User          = ""
                    pr(i&).SocketTimeout = 0           ' Socket-Timeout erstmal ausschalten
                    pr(i&).SocketError   = %False      ' und dann nachher per Thread setzen
                    FUNCTION = i&
                ELSE
                    Logwrite "Failed connection to '" + HostTemp$ + "'  Port:" + STR$(ServerPort&), i&, %LogState_OtherError
                    WSACleanup
                    EXIT FUNCTION
                END IF
            END IF
        END IF

END FUNCTION



FUNCTION TCP_Print(BYVAL hSocket AS LONG, BYVAL TEXT AS STRING) AS LONG

        LOCAL Buffer       AS STRING      '
        LOCAL Result       AS LONG        '
        LOCAL StartTime    AS SINGLE
        LOCAL CurrentTime  AS SINGLE
        LOCAL LastError    AS LONG        '

        pr(hSocket).SocketExitus = pr(hSocket).SocketTimeout

        Buffer$ = TEXT + CrLf$

        FUNCTION = TCP_Send(hSocket, Buffer)

END FUNCTION

FUNCTION TCP_Send (BYVAL hSocket AS LONG, BYVAL TEXT AS STRING) AS LONG

        LOCAL Buffer       AS STRING      '
        LOCAL Result       AS LONG        '
        LOCAL StartTime    AS SINGLE
        LOCAL CurrentTime  AS SINGLE
        LOCAL LastError    AS LONG        '

        IF hSocket > 0 THEN

            StartTime = TIMER
            pr(hSocket).SocketExitus = pr(hSocket).SocketTimeout
            Buffer$ = Text$

            Result& = sSEND(pr(hsocket).hSocket, BYVAL(STRPTR(Buffer$)), LEN(Buffer$), 0)

            IF DebugLine = %True THEN
                $IF %Console_Win
                STDOUT TRIM$(STR$(hSocket)) + ">:" + Buffer
                $ENDIF
            END IF
            IF Result& = -1 THEN
                LastError = WSAGetLastError
                SELECT CASE LastError
                    ' keine Zeichen empfangen
                    CASE %WsaEWouldBlock
                        Logwrite "Send_Empty", hSocket, %LogState_Debug

                        IF pr(hSocket).SocketTimeout > 0 THEN
                            ' internen Time anlaufen lassen
                            CurrentTime = TIMER
                            ' Mitternachtsumbruch
                            IF CurrentTime < StartTime THEN
                               CurrentTime = CurrentTime + 86400
                            END IF
                            IF CurrentTime > StartTime + pr(hsocket).SocketTimeout THEN
                               Logwrite "Send_Socket_Timeout", hSocket, %LogState_Debug
                               pr(hsocket).SocketError = %True
                            END IF
                    END IF
                    ' Verbindung wurde unterbrochen
                    CASE %WsaEConnReset
                        LogWrite "Send_Conn_Reset", hSocket, %LogState_Debug
                        pr(hsocket).SocketError = %True
                    CASE %WsaEConnAborted
                        LogWrite "Send_Conn_Abort", hSocket, %LogState_Debug
                        pr(hsocket).SocketError = %True
                    CASE %WsaETimedOut
                        LogWrite "Send_Reset", hSocket, %LogState_Debug
                        pr(hsocket).SocketError = %True
                    CASE %WsaEInval
                        LogWrite "Send_Invalid_Socket", hSocket, %LogState_Debug
                        pr(hsocket).SocketError = %True
                    CASE %WsaENotSock
                        LogWrite "Send_No_Socket", hSocket, %LogState_Debug
                        pr(hsocket).SocketError = %True
                    CASE ELSE
                        LogWrite "Send_Unknown" + STR$(LastError), hSocket, %LogState_Debug
                        pr(hsocket).SocketError = %True
                END SELECT
                SLEEP 10
            END IF
        END IF
'        LOOP UNTIL pr(hsocket).SocketError = %True

END FUNCTION


SUB TCP_Line(BYVAL hSocket AS LONG, Buffer AS STRING)

        LOCAL RcvdBuffer   AS ASCIIZ*2048 '
        LOCAL Result       AS LONG        '
        LOCAL c            AS LONG        ' Position des Cr

        LOCAL StartTime    AS SINGLE
        LOCAL CurrentTime  AS SINGLE
        LOCAL LastError    AS LONG

        IF hSocket > 0 THEN

            StartTime = TIMER
            pr(hSocket).SocketExitus = pr(hSocket).SocketTimeout
            DO
                c = INSTR(TempBuffer(hSocket), Lf$)
                IF c > 0 THEN
                    Buffer = LEFT$(TempBuffer(hSocket), c - 2 )
                    TempBuffer(hSocket) = MID$(Tempbuffer(hSocket), c + 1)
                    IF DebugLine = %True THEN
                        $IF %Console_Win
                        STDOUT TRIM$(STR$(hSocket)) + "<:" + Buffer
                        $ENDIF
                    END IF
                    EXIT DO
                ELSE
                    Result = rRECV(pr(hSocket).hSocket, RcvdBuffer, SIZEOF(RcvdBuffer), 0)
                    IF Result > 0 THEN
                        TempBuffer(hSocket) = TempBuffer(hSocket) + LEFT$(RcvdBuffer, Result)
                    ELSE
                        LastError = WSAGetLastError
                    END IF
                END IF
                IF Result& < 0 THEN
                    SELECT CASE LastError
                        ' Buffer war zu klein
                        CASE %WsaEMsgSize
                            Logwrite "Buffer too small", hSocket, %LogState_Debug
                        ' keine Zeichen empfangen
                        CASE %WsaEWouldBlock
                             IF DebugLine = %True THEN
                                 LogWrite "Line_Buffer_Empty", hSocket, %LogState_Debug
                             END IF
                             SLEEP 10
                             IF pr(hSocket).SocketTimeout > 0 THEN
                                 ' internen Time anlaufen lassen
                                 CurrentTime = TIMER
                                 ' Mitternachtsumbruch
                                 IF CurrentTime < StartTime THEN
                                    CurrentTime = CurrentTime + 86400
                                 END IF
                                 'STDOUT "Timeout in" + STR$(( (StartTime + pr(hsocket).SocketTimeout)) - CurrentTime) + " seconds"
                                 IF CurrentTime > StartTime + pr(hsocket).SocketTimeout THEN
                                     Logwrite "Line_Socket_Timeout", hSocket, %LogState_Debug
                                     pr(hsocket).SocketError = %True
                                 END IF
                             END IF
                        ' Verbindung wurde unterbrochen
                        CASE %WsaEConnReset
                            Logwrite "Line_Conn_Reset", hSocket, %LogState_Debug
                            pr(hsocket).SocketError = %True
                        CASE %WsaEConnAborted
                            Logwrite "Line_Conn_Abort", hSocket, %LogState_Debug
                            pr(hsocket).SocketError = %True
                        CASE  %WsaETimedOut
                            Logwrite "Line_Conn_Timeout", hSocket, %LogState_Debug
                            pr(hsocket).SocketError = %True
                        CASE ELSE
                            Logwrite "Line_Unknown:" + STR$(LastError), hSocket, %LogState_Debug
                            pr(hsocket).SocketError = %True
                    END SELECT
                    SLEEP 1
                END IF
            LOOP WHILE pr(hsocket).SocketError = %False
        END IF
END SUB

FUNCTION TCP_Copy(BYVAL hFrom AS LONG, BYVAL hDest AS LONG) AS LONG

        LOCAL Buffer       AS STRING      '
        LOCAL BurstBuffer  AS STRING      '

        IF hFrom > 0 AND hDest > 0 THEN

            BurstBuffer = ""
            DO
                TCP_Line hFrom, Buffer$
                IF Buffer = "." THEN
                    TCP_Send hDest, BurstBuffer$ + Buffer + CrLf$
                    BurstBuffer = ""
                ELSE
                    BurstBuffer = BurstBuffer + Buffer$ + CrLf$
                    IF LEN(BurstBuffer) > 1024 THEN
                        TCP_Send hDest, BurstBuffer$
                        BurstBuffer = ""
                    END IF
                END IF
            LOOP UNTIL Buffer = "." OR pr(hFrom).SocketError = %True OR pr(hDest).SocketError = %True

        END IF

END FUNCTION

FUNCTION TCP_Close(BYVAL hTcp AS LONG)

        IF hTcp > 0 THEN
            TempBuffer(hTcp) = ""                 ' verbliebenen LineIn bzw. Received-Buffer lschen
            IF Closesocket(pr(hTcp).hSocket) = 0 THEN
                LogWrite "Socket closed", hTcp, %LogState_Normal
                FUNCTION = %True
            ELSE
                LogWrite "Socket already closed", hTcp, %LogState_OtherError
                FUNCTION = %False
            END IF
        END IF

END FUNCTION

SUB TCP_Abort(BYVAL i AS LONG)

        LOCAL t            AS LONG        ' Temp
        LOCAL User         AS STRING      '
        LOCAL Result       AS LONG        '

        LogWrite "Socket is dead, perform killing Thread", i&, %LogState_FatalError

        TCP_Close i&
        SLEEP 100

END SUB

'-------------------------------------------------------------------------------------------
' Spam-Proxy Kernel starten und initalisieren
'-------------------------------------------------------------------------------------------
FUNCTION SpamProxy(BYVAL Dummy AS LONG) AS LONG

        $IF %Console_Win
        INPUT FLUSH                       ' Tastaturpuffer aufrumen
        $ENDIF

        LOCAL Title        AS ASCIIZ * 200'
        LOCAL ProxyStatus  AS LONG        '
        LOCAL ProxyExit    AS INTEGER     ' alle Threads fertig = %True
        LOCAL hPop3Proxy   AS LONG
        LOCAL hNntpProxy   AS LONG
        LOCAL Pop3Status   AS LONG
        LOCAL NntpStatus   AS LONG
        LOCAL Parameter    AS STRING      ' enthlt Kommandozeile
        LOCAL szMutex1     AS ASCIIZ * 32 '
        LOCAL szMutex2     AS ASCIIZ * 32 '
        LOCAL szMutex3     AS ASCIIZ * 32 '
        LOCAL szMutex4     AS ASCIIZ * 32 '
        LOCAL szMutex5     AS ASCIIZ * 32 '
        LOCAL Result       AS LONG        '
        LOCAL i            AS LONG        ' Temp
        LOCAL Temp         AS STRING

        DIM Pr(100)        AS GLOBAL Thread_Data
        DIM Pop3KillMsg(%Threads)         ' Array fr Killreports
        DIM TempBuffer(%Threads)          ' interner Buffer fr TCP_Line & TCP_Send/Print

        DIM wDat     AS WSAdata
        DIM dip_addr AS ASCIIZ PTR

        $INCLUDE "SPAMPRXY.VER"
        sLogApp        = "SpamProxy " + Version$
        CrLf$          = CHR$(13,10)
        Lf$            = CHR$(10)
        Eol$           = CHR$(13,10)

        MsgNoSuch      = "-ERR no such message"
        MsgCmdUnknown  = "-ERR unknown command"

        ' File/Handle-Sharing
        szMutex1     = "spam_proxy_fileopen"
        Mutex_Io     = CreateMutex(BYVAL %NULL, %FALSE, szMutex1)
        ' Incoming Connect
        szMutex2     = "spam_proxy_handle_thread"
        Mutex_Accept = CreateMutex(BYVAL %NULL, %FALSE, szMutex2)
        ' CrossSecretary
        szMutex3     = "spam_proxy_cs"
        Mutex_CS     = CreateMutex(BYVAL %NULL, %FALSE, szMutex2)
'       Mutex_Cs   = CreateMutex(BYVAL %NULL, %FALSE, szMutex5)

        Title = "SpamProxy " + Version$ + " transparent, internal Design & Test (Console Debug)"

        $IF %Console_Win
        STDOUT Title
        $ENDIF

        IF WsaStartup(257, wdat) = 0 THEN
            SetConsoleTitle Title
            LogOpen
            '--[CrossSecretary Konfiguration laden]---------------------------------------------
            IF KillFile$ <> "" THEN
                IF CS_Init(KillFile$, FilterCfg$()) = %True THEN
                    CS = %True
                    Logwrite "Loading filter configuration", -1, %LogState_BriefMsg
                ELSE
                    Logwrite "Filter configuration not found", -1, %LogState_BriefMsg
                END IF
            END IF

            RBL_Open                       ' Pop3-RelayBlacklist ffnen
            IP_Open                        ' IP-Zugriffsliste ffnen

            THREAD CREATE Pop3Listen(Pop3PortIncoming&) TO hPop3Proxy
            SLEEP 10
            THREAD CREATE NntpListen(NntpPortIncoming&) TO hNntpProxy
            SLEEP 10
            THREAD STATUS hPop3Proxy& TO Pop3Status
            THREAD STATUS hNntpProxy& TO NntpStatus

            IF Pop3Status > 1 AND NntpStatus > 1 THEN
                DO
                    SLEEP 1000        ' alle Sekunde die Tastatur abfragen
                    FOR i& = 1 TO 99
                        IF pr(i&).hThread > 0 THEN
                            ' nur Auswerten wenn Timeout eingeschaltet
                            IF pr(i&).SocketTimeout > 0 THEN
                                DECR pr(i&).SocketExitus
                                IF pr(i&).SocketExitus = 0 THEN
                                    TCP_Abort i&
                                END IF
                            END IF
                        END IF
                    NEXT i&
                    $IF %Console_Win
                    Key$ = INKEY$
                    $ENDIF
                    SELECT CASE LCASE$(Key$)
                        CASE CHR$(13)
                            FOR i& = 1 TO 99
                                IF pr(i&).hThread > 0 THEN
                                    dip_addr = inet_ntoa(pr(i).ip)
                                    $IF %Console_Win
                                    STDOUT TIME$ + ":  ";
                                    STDOUT @dip_addr + ":" + TRIM$(STR$(pr(i).Portnummer))+ _
                                          " ID"+STR$(i) + " S" + STR$(pr(i).hSocket) + _
                                          " T" +STR$(pr(i).SocketExitus)+ " "+ _
                                          pr(i).user
                                    $ENDIF
                                END IF
                            NEXT i&
                        CASE "k", CHR$(27)
                            FOR i& = 1 TO 99
                                IF pr(i&).hThread > 0 THEN
                                    TCP_Close i&
                                    LogWrite "Thread" + STR$(i&) + " killed by User", i&, %LogState_Normal
                                END IF
                            NEXT i&
                        CASE ""
                        CASE ELSE
                    END SELECT
                LOOP WHILE Key$ <> CHR$(27) AND Errorflag = 0
                THREAD SUSPEND hPop3Proxy& TO Pop3Status
                THREAD SUSPEND hNntpProxy& TO NntpStatus
                SLEEP 50
                THREAD CLOSE hPop3Proxy& TO Pop3Status
                THREAD CLOSE hNntpProxy& TO NntpStatus
            END IF
            SLEEP 50
            IF WsaCleanup = 0 THEN
                ' Ok
            ELSE
                ' Fehler
            END IF
        ELSE
            LogWrite "Winsock Error", -1, %LogState_FatalError
        END IF
        LogClose

'        Closehandle Mutex_Io
'        Closehandle Mutex_Accept
'        CLOSE
'  Closehandle Mutex3
        SLEEP 50

END FUNCTION

$IF %Console_Win
'-------------------------------------------------------------------------------------------
' Console
'-------------------------------------------------------------------------------------------                                                                                                                                                                   _
FUNCTION PBMAIN() AS LONG

        LOCAL Dummy        AS LONG
        SpamProxy Dummy

END FUNCTION

$ELSE
'-------------------------------------------------------------------------------------------
' grafische Version mit TrayIcon
'-------------------------------------------------------------------------------------------
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  lpCmdLine           AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG


        LOCAL Msg          AS tagMsg      '
        LOCAL wndclass     AS WndClassEx
        LOCAL szAppName    AS ASCIIZ * 80 '
        LOCAL hWnd         AS LONG
        LOCAL Dummy        AS LONG

        hInst = hInstance

        THREAD CREATE SpamProxy(Dummy) TO hSpamProxy

        szAppName = "SpamProxy " + Version$

        wndclass.cbSize        = SIZEOF(WndClass)
        wndclass.style         = %CS_HREDRAW OR %CS_VREDRAW
        wndclass.lpfnWndProc   = CODEPTR(WndProc)
        wndclass.cbClsExtra    = 0
        wndclass.cbWndExtra    = 0
        wndclass.hInstance     = hInstance
        wndclass.hIcon         = LoadIcon(hInstance, "SPAMPROXY_1")
        wndclass.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
        wndclass.hbrBackground = GetStockObject(%WHITE_BRUSH)
        wndclass.lpszMenuName  = %NULL
        wndclass.lpszClassName = VARPTR(szAppName)
        wndclass.hIconSm       = LoadIcon(hInstance, BYVAL %IDI_APPLICATION)

        RegisterClassEx wndclass

       ' Create a window using the registered class
       hWnd = CreateWindow(szAppName, _               ' window class name
                           "SpamProxy " + Version$ + _
                           "(Alpha)", _               ' window caption
                           %WS_OVERLAPPEDWINDOW, _    ' window style
                           %CW_USEDEFAULT, _          ' initial x position
                           %CW_USEDEFAULT, _          ' initial y position
                           %CW_USEDEFAULT, _          ' initial x size
                           %CW_USEDEFAULT, _          ' initial y size
                           %NULL, _                   ' parent window handle
                           %NULL, _                   ' window menu handle
                           hInstance, _               ' program instance handle
                           BYVAL %NULL)               ' creation parameters

        ' Display the window on the screen
        'ShowWindow hWnd, iCmdShow
        'UpdateWindow hWnd

        WHILE GetMessage(Msg, %NULL, 0, 0)
            TranslateMessage Msg
            DispatchMessage Msg
        WEND

        FUNCTION = msg.wParam

END FUNCTION  ' WinMain

FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL wMsg AS LONG, _
                 BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG

        STATIC hMenu       AS LONG        '
        STATIC hInfo       AS LONG
        STATIC Ti          AS NOTIFYICONDATA
        STATIC p           AS POINTAPI
        STATIC DialogAbout AS LONG
        STATIC DialogStart AS LONG
        STATIC DialogExit  AS LONG
        STATIC Result      AS LONG       '
        STATIC ResultTime  AS LONG

        SELECT CASE wMsg

            CASE %WM_INITDIALOG
            CASE %WM_CREATE

                ' doppeltes Starten der Dialoge vermeiden
                DialogAbout = %False
                DialogStart = %False
                DialogExit  = %False

                ' Eintrge fr TrayIcon aus Resource lesen
                hMenu = GetSubMenu(LoadMenu(hInst, "POPUPMENU"), 0)
                ' TrayIcon hinzufgen
                Ti.cbSize           = SIZEOF(Ti)
                Ti.hWnd             = hWnd
                Ti.uID              = hInst
                Ti.uFlags           = %NIF_ICON OR %NIF_MESSAGE OR %NIF_TIP
                Ti.uCallbackMessage = %WM_TRAYICON
                Ti.hIcon            = LoadIcon(hInst, "SPAMPROXY_2")
                'Ti.hIcon            = ExtractIcon(hInst, "C:\BASIC\SPAMPRXY\SPAMPRXY.EXE", 0&)
                Ti.szTip            = "SpamProxy " + Version$
                Shell_NotifyIcon %NIM_ADD, ti
                DestroyIcon ti.hIcon

            CASE %WM_PAINT
                FUNCTION = 0
                EXIT FUNCTION

            CASE %WM_TRAYICON
                SELECT CASE LOWRD(lParam)
                    'linker Mousebutton
                    CASE %WM_LBUTTONDOWN
                        IF DialogStart = %False THEN
                            DialogStart = %True
                            DialogBox hInst, "STARTUP" + CHR$(0), %HWND_DESKTOP, CODEPTR(StartupProc)
                            DialogStart = %False
                        END IF
                    'rechter Mousebutton
                    CASE %WM_RBUTTONDOWN
                        SetForegroundWindow hWnd
                        GetCursorPos p
                        TrackPopupMenu hMenu, 0, p.x, p.y, 0, hWnd, BYVAL %NULL
                        Postmessage hWnd, %WM_NULL, 0, 0
                    CASE ELSE
                END SELECT

            CASE %WM_ERASEBKGND
                FUNCTION = 1
                EXIT FUNCTION

            CASE %WM_DESTROY
                Key$ = CHR$(27)
                ResultTime& = 50            ' nach 5 Sekunden werden Threads gewaltsam entfernt
                DO
                     DECR ResultTime&
                     SLEEP 100              ' all 1/10 Sekunde abfragen
                     THREAD STATUS hSpamProxy TO Result&
                LOOP WHILE Result& = &h103 AND ResultTime& > 0
                Shell_NotifyIcon %NIM_DELETE, Ti
                PostQuitMessage 0
                FUNCTION = 0
                EXIT FUNCTION

            CASE %WM_COMMAND
                SELECT CASE LOWRD(wParam)
                    CASE %IDOK
                        IF DialogAbout = %False THEN
                            DialogAbout = %True
                            DialogBox hInst, "ABOUT" + CHR$(0), %HWND_DESKTOP, CODEPTR(AboutProc)
                            DialogAbout = %False
                        END IF
                    CASE %IDCANCEL
                        IF DialogExit = %False THEN
                            DialogExit = %True
                            IF MessageBox(hWnd,"Close all connections and remove SpamProxy?" , "SpamProxy " + Version$, %MB_ICONEXCLAMATION OR %MB_OKCANCEL) = %IDOK THEN
                                 SendMessage hWnd, %WM_Destroy, 0 , 0
                                 FUNCTION = 1
                            END IF
                            DialogExit = %False
                        END IF
                    END SELECT

            CASE %WM_SYSCOMMAND
        END SELECT

        ' restliche Abfragen an den Default-Message-Handler von Windows bergeben
        FUNCTION = DefWindowProc(hWnd, wMsg, wParam, lParam)

END FUNCTION

FUNCTION AboutProc(BYVAL hDlg AS LONG, BYVAL wMsg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG

        SELECT CASE wMsg
            CASE %WM_INITDIALOG
                FUNCTION = 1
            CASE %WM_COMMAND
                IF LOWRD(wParam) = %IDOK THEN
                    EndDialog hDlg, 0
                    FUNCTION = 1
                END IF
        END SELECT

END FUNCTION

FUNCTION StartupProc(BYVAL hDlg AS LONG, BYVAL wMsg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG

        SELECT CASE wMsg
            CASE %WM_INITDIALOG
                SetForegroundWindow hDlg
                FUNCTION = 1

            CASE %WM_COMMAND
                SELECT CASE LOWRD(wParam)
                    CASE 101
                        EndDialog hDlg, 0
                    CASE %IDCANCEL
                    CASE %IDOK
                        EndDialog hDlg, 0
                        FUNCTION = 1
               END SELECT
        END SELECT

END FUNCTION

$ENDIF

'-------------------------------------------------------------------------------------------
' [EOF]                                  (c) 2002-2003 by Thomas Gohel <gohel@basicguru.com>
'-------------------------------------------------------------------------------------------



                                                                     